// FIX FOR DECALS CLIPPING// FIX FOR DECALS CLIPPING
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   


struct _819
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1079
{
    int _m0;
    int _m1;
};

struct _1082
{
    int _m0;
    int _m1;
};

struct _1193
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2060
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3394
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _840_842
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
} _842;

layout(set = 2, binding = 0, std140) uniform _923_925
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _925;

layout(set = 1, binding = 0, std140) uniform _973_975
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _975;

layout(set = 0, binding = 4, std430) restrict readonly buffer _1084_1086
{
    _1082 _m0[];
} _1086;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1168_1170
{
    uint _m0[];
} _1170;

layout(set = 0, binding = 6, std140) uniform _1198_1200
{
    vec4 _m0[4096];
} _1200;

layout(set = 0, binding = 7, std140) uniform _1218_1220
{
    vec4 _m0[4096];
} _1220;

layout(set = 0, binding = 8, std140) uniform _1270_1272
{
    vec4 _m0[4096];
} _1272;

layout(set = 0, binding = 10, std140) uniform _2064_2066
{
    vec4 _m0[4096];
} _2066;

layout(set = 0, binding = 11, std140) uniform _2103_2105
{
    vec4 _m0[4096];
} _2105;

layout(set = 0, binding = 12, std140) uniform _2172_2174
{
    vec4 _m0[3072];
} _2174;

layout(set = 0, binding = 15, std140) uniform _3398_3400
{
    vec4 _m0[4095];
} _3400;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4446_4448
{
    vec4 _m0[];
} _4448;

layout(push_constant, std430) uniform _4442_4444
{
    int _m0;
    int _m1;
} _4444;

layout(set = 2, binding = 1) uniform SAMPLER_2D _931;
layout(set = 2, binding = 2) uniform SAMPLER_2D _939;
layout(set = 2, binding = 3) uniform SAMPLER_2D _944;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1492;
layout(set = 0, binding = 13) uniform samplerCubeArray _2570;
layout(set = 0, binding = 14) uniform SAMPLER_2D _2956;
layout(set = 0, binding = 16) uniform sampler2DShadow _3721;
layout(set = 0, binding = 17) uniform sampler3D _4203;
layout(set = 0, binding = 18) uniform sampler3D _4224;
layout(set = 0, binding = 19) uniform sampler3D _4341;
layout(set = 0, binding = 20) uniform SAMPLER_2D _4413;
layout(set = 0, binding = 2) uniform sampler3D _4449;
layout(set = 0, binding = 3) uniform sampler3D _4450;

layout(location = 2) in vec4 _833;
layout(location = 6) in vec4 _847;
layout(location = 3) in vec4 _859;
layout(location = 4) in vec4 _862;
layout(location = 5) in vec4 _865;
layout(location = 10) in vec4 _883;
layout(location = 11) in vec4 _887;
layout(location = 12) in vec4 _891;
layout(location = 0) out vec4 _4121;
layout(location = 1) out vec4 _4395;
layout(location = 2) out vec4 _4396;

float _277;

float _51(float _50)
{
    if (_50 <= 0.040449999272823333740234375)
    {
        return _50 / 12.9200000762939453125;
    }
    else
    {
        return pow((_50 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _54(vec3 _53)
{
    float _279 = _53.x;
    vec3 _278;
    _278.x = _51(_279);
    float _285 = _53.y;
    _278.y = _51(_285);
    float _291 = _53.z;
    _278.z = _51(_291);
    return _278;
}

vec4 _57(vec4 _56)
{
    vec3 _301 = _56.xyz;
    vec4 _300 = vec4(_54(_301), 1.0);
    float _309 = _56.w;
    _300.w = _51(_309);
    return _300;
}

vec4 _69(vec4 _68)
{
    vec4 _367 = _68;
    return _57(_367);
}

vec4 _121(SAMPLER_2D _119, vec2 _120)
{
    vec4 _563 = SAMPLE_TEXTURE(_119, _120);
    vec4 _567 = _563;
    _563 = _69(_567);
    return _563;
}

float _159(float _155, vec4 _156, float _157, bool _158)
{
    float _755 = _156.w / (_155 + _156.z);
    return _755 * _157;
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

vec3 _164(vec3 _162, bool _163)
{
    vec3 _768 = (_162 * 2.0) - vec3(1.0);
    float _785 = (1.0 - (_768.x * _768.x)) - (_768.y * _768.y);
    _768.z = sqrt(_14(_785));
    if (_163 == false)
    {
        _768.z = -_768.z;
    }
    return _768;
}

vec3 _171(vec3 _169, mat3 _170)
{
    return normalize(vec3(dot(_169, _170[0]), dot(_169, _170[1]), dot(_169, _170[2])));
}

uint _31(float _30)
{
    return floatBitsToUint(_30);
}

float _42(float _39, float _40, float _41)
{
    return min(_39, min(_40, _41));
}

float _37(float _34, float _35, float _36)
{
    return max(_34, max(_35, _36));
}

vec4 _98(uint _97)
{
    return unpackUnorm4x8(_97).wzyx;
}

vec4 _111(uvec2 _110)
{
    return vec4(float((_110.x >> uint(16)) & 65535u), float(_110.x & 65535u), float((_110.y >> uint(16)) & 65535u), float(_110.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _128(SAMPLER_2D _124, vec2 _125, vec2 _126, vec2 _127)
{
    return TEXTURE_GRAD(_124, _125, _126, _127);
}

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

float _60(float _59)
{
    return _59 * ((_59 * ((_59 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _101(uint _100)
{
    return vec4(float((_100 >> uint(24)) & 255u), float((_100 >> uint(16)) & 255u), float((_100 >> uint(8)) & 255u), float(_100 & 255u));
}

vec3 _63(vec3 _62)
{
    float _332 = _62.x;
    vec3 _331;
    _331.x = _60(_332);
    float _337 = _62.y;
    _331.y = _60(_337);
    float _342 = _62.z;
    _331.z = _60(_342);
    return _331;
}

vec4 _66(vec4 _65)
{
    vec3 _351 = _65.xyz;
    vec4 _350 = vec4(_63(_351), 1.0);
    float _359 = _65.w;
    _350.w = _60(_359);
    return _350;
}

float _80(float _79)
{
    return (step(0.0, _79) * 2.0) - 1.0;
}

vec4 _26(vec4 _25)
{
    return clamp(_25, vec4(0.0), vec4(1.0));
}

float _72(float _71)
{
    return exp2(_71);
}

vec3 _131(uint _130)
{
    uint _581 = _130;
    vec4 _580 = _98(_581);
    float _592 = (_580.w * 255.0) - 128.0;
    return _580.xyz * _72(_592);
}

vec3 _150(float _147, float _148, vec3 _149)
{
    float _707 = 0.0949999988079071044921875 + (_148 * (0.60000002384185791015625 + (4.190000057220458984375 * _148)));
    float _717 = _147 + 0.02500000037252902984619140625;
    float _721 = (9.5 * _148) * _147;
    float _735 = 1.0 - (14.0 * _147);
    float _727 = (_707 * _717) * _72(_735);
    float _742 = -_721;
    float _738 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _72(_742)));
    return mix(vec3(_727), vec3(_738), _149);
}

vec3 _105(uint _104)
{
    return vec3(float((_104 >> uint(21)) & 2047u), float((_104 >> uint(10)) & 2047u), float(_104 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _48(float _45, float _46, float _47)
{
    bool _218 = abs(_47) >= abs(_45);
    bool _226;
    if (_218)
    {
        _226 = abs(_47) >= abs(_46);
    }
    else
    {
        _226 = _218;
    }
    if (_226)
    {
        return uint((_47 < 0.0) ? 5 : 4);
    }
    if (abs(_46) >= abs(_45))
    {
        return uint((_46 < 0.0) ? 3 : 2);
    }
    return uint(int(_45 < 0.0));
}

float _77(float _75, float _76)
{
    return pow(_75, _76);
}

vec3 _20(vec3 _19)
{
    return clamp(_19, vec3(0.0), vec3(1.0));
}

vec3 _136(vec3 _134, float _135)
{
    float _604 = 50.0 * dot(_134, vec3(0.33329999446868896484375));
    float _597 = _14(_604);
    float _613 = 1.0 - _135;
    float _616 = _14(_613);
    float _617 = 5.0;
    vec3 _621 = _134 + ((vec3(_597) - _134) * _77(_616, _617));
    return _20(_621);
}

vec3 _144(vec3 _139, vec3 _140, vec3 _141, vec3 _142, float _143)
{
    vec3 _625 = normalize(_140 + _141);
    float _630 = 1.0 - (_143 * 0.800000011920928955078125);
    _630 *= _630;
    _630 *= _630;
    float _641 = _630 * _630;
    float _649 = dot(_139, _625);
    float _645 = _14(_649);
    float _651 = ((_645 * _645) * (_641 - 1.0)) + 1.0;
    _651 = _641 / ((_651 * _651) + 9.9999999392252902907785028219223e-09);
    float _670 = dot(_139, _140);
    float _666 = (_14(_670) * (1.0 - _630)) + _630;
    float _681 = dot(_139, _141);
    float _677 = (_14(_681) * (1.0 - _630)) + _630;
    _651 /= (((4.0 * _666) * _677) + 9.9999999392252902907785028219223e-09);
    vec3 _699 = _142;
    float _701 = dot(_141, _625);
    return _136(_699, _701) * _651;
}

float _83(float _82)
{
    float _388 = (((-0.15658299624919891357421875) * abs(_82)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_82));
    float _402;
    if (_82 >= 0.0)
    {
        _402 = _388;
    }
    else
    {
        _402 = 3.1415927410125732421875 - _388;
    }
    return _402;
}

float _86(float _85)
{
    float _416;
    if (_85 < 1.0)
    {
        _416 = _85;
    }
    else
    {
        _416 = 1.0 / _85;
    }
    float _413 = _416;
    float _424 = _413 * _413;
    float _428 = 0.087292902171611785888671875;
    _428 = (-0.3018949925899505615234375) + (_428 * _424);
    _428 = 1.0 + (_428 * _424);
    _428 *= _413;
    float _444;
    if (_85 < 1.0)
    {
        _444 = _428;
    }
    else
    {
        _444 = 1.57079637050628662109375 - _428;
    }
    return _444;
}

float _89(float _88)
{
    float _457 = abs(_88);
    float _454 = _86(_457);
    float _461;
    if (_88 < 0.0)
    {
        _461 = -_454;
    }
    else
    {
        _461 = _454;
    }
    return _461;
}

float _93(float _91, float _92)
{
    float _475 = _91 / _92;
    float _471 = _89(_475);
    if (_92 < 0.0)
    {
        _471 += ((_91 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _471;
}

void main()
{
    _819 _821 = _819(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _821._m15 = _833;
    _821._m16 = gl_FragCoord;
    _821._m14 = _842._m4.xyz + _847.xyz;
    _821._m13 = normalize(-_847.xyz);
    _821._m17 = mat3(vec3(_859.xyz), vec3(_862.xyz), vec3(_865.xyz));
    _821._m34 = _883;
    _821._m35 = _887;
    _821._m36 = _891;
    uint _894 = 0u;
    vec4 _895 = vec4(0.0);
    vec4 _896 = vec4(0.0);
    vec4 _897 = vec4(0.0);
    vec4 _898 = vec4(0.0);
    vec4 _899 = vec4(0.0);
    _821._m0 = _897.xyz;
    _821._m2 = _898.xyz;
    _821._m1 = _896.xyz;
    _821._m9 = _895.xyz;
    _821._m3 = _895.w;
    _821._m6 = _899.wyz;
    vec2 _920 = _833.xy * _925._m2.xy;
    vec2 _932 = _920;
    vec4 _930 = _121(_931, _932);
    vec4 _935 = vec4(0.07999999821186065673828125);
    vec4 _938 = SAMPLE_TEXTURE(_939, _920);
    float _943 = SAMPLE_TEXTURE(_944, _920).x;
    _821._m0 = _925._m3.xyz * _930.xyz;
    _821._m11 = _925._m3.w * _930.w;
    _821._m2 = _935.xyz;
    _821._m3 = _943;
    _821._m6 = _938.xyz;
    uint _972 = uint((_975._m6.x > 0.0) ? 8 : 0);
    float _981 = 16.0;
    float _983 = 8.0;
    float _985 = 24.0;
    vec2 _994 = _821._m16.xy * _842._m6.xy;
    vec3 _987;
    _987 = vec3(_994.x, _994.y, _987.z);
    _987.y = 1.0 - _987.y;
    
       // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
    _987.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1007 = floor(_987.xy * vec2(_981, _983));
    _987 = vec3(_1007.x, _1007.y, _987.z);
    float _1012 = _821._m16.z;
    vec4 _1015 = _842._m7;
    float _1018 = 1.0;
    bool _1019 = false;
    float _1010 = _159(_1012, _1015, _1018, _1019);
    float _1021 = log2(max(1.0, _1010 / _842._m8.z)) * _842._m8.w;
    _987.z = min(_985 - 1.0, floor(_1021));
    uint _1037 = uint((_987.x + (_987.y * _981)) + ((_987.z * _981) * _983));
    bool _1053 = true;
    vec3 _1055 = _821._m6;
    bool _1058 = _1053;
    _821._m7 = _164(_1055, _1058);
    vec3 _1062 = _821._m7;
    mat3 _1065 = _821._m17;
    _821._m6 = _171(_1062, _1065);
    uint _1070 = 0u;
    uint _1071 = 0u;
    uint _1072 = 0u;
    uint _1073 = 0u;
    uint _1074 = 0u;
    uint _1075 = 0u;
    int _1077 = 256;
    _1079 _1081;
    _1081._m0 = _1086._m0[_1037]._m0;
    _1081._m1 = _1086._m0[_1037]._m1;
    int _1095 = _1081._m0 & (~(_1081._m0 >> 31));
    int _1104 = _1081._m1 & (~(_1081._m1 >> 31));
    _1070 = uint((_1095 >> 16) * _1077);
    _1071 = _1070 + uint(_1104 & 255);
    _1072 = _1070;
    _1073 = _1072 + uint((_1104 >> 8) & 255);
    _1074 = _1070;
    _1075 = _1074 + uint((_1104 >> 16) & 255);
    vec3 _1137 = dFdx(_821._m14);
    vec3 _1141 = dFdy(_821._m14);
    bool _1146 = _972 == 0u;
    bool _1152;
    if (_1146)
    {
        _1152 = _975._m6.y == 0.0;
    }
    else
    {
        _1152 = _1146;
    }
    _1072 = _1152 ? _1073 : _1072;
    uint _1156 = _1072;
    _1193 _1195;
    vec3 _1560;
    float _1693;
    while (_1156 < _1073)
    {
        uint _1166 = _1170._m0[_1156];
        uint _1175 = (_1166 >> uint(12)) & 4095u;
        uint _1181 = _1175;
        if (_1181 >= _1175)
        {
            _1156++;
        }
        int _1190 = 2;
        int _1191 = 2;
        int _1192 = 2;
        _1195._m0 = _1200._m0[(uint(_1190) * _1181) + 0u];
        _1195._m1 = _1200._m0[(uint(_1190) * _1181) + 1u];
        _1195._m2 = _1220._m0[(uint(_1191) * _1181) + 0u];
        float _1234 = _1220._m0[(uint(_1191) * _1181) + 1u].x;
        _1195._m3.x = _31(_1234);
        float _1244 = _1220._m0[(uint(_1191) * _1181) + 1u].y;
        _1195._m3.y = _31(_1244);
        float _1254 = _1220._m0[(uint(_1191) * _1181) + 1u].z;
        _1195._m4.x = _31(_1254);
        float _1264 = _1220._m0[(uint(_1191) * _1181) + 1u].w;
        _1195._m4.y = _31(_1264);
        float _1278 = _1272._m0[(uint(_1192) * _1181) + 0u].x;
        _1195._m5.x = _31(_1278);
        float _1288 = _1272._m0[(uint(_1192) * _1181) + 0u].y;
        _1195._m5.y = _31(_1288);
        float _1298 = _1272._m0[(uint(_1192) * _1181) + 0u].z;
        _1195._m6 = _31(_1298);
        float _1308 = _1272._m0[(uint(_1192) * _1181) + 0u].w;
        _1195._m7 = _31(_1308);
        float _1318 = _1272._m0[(uint(_1192) * _1181) + 1u].x;
        _1195._m8 = _31(_1318);
        float _1328 = _1272._m0[(uint(_1192) * _1181) + 1u].y;
        _1195._m9 = _31(_1328);
        float _1338 = _1272._m0[(uint(_1192) * _1181) + 1u].z;
        _1195._m10 = _31(_1338);
        float _1348 = _1272._m0[(uint(_1192) * _1181) + 1u].w;
        _1195._m11 = _31(_1348);
        vec4 _1353 = _1195._m0;
        vec4 _1356 = _1195._m2;
        vec4 _1359 = _1195._m1;
        vec4 _1362 = vec4(_821._m14, 1.0);
        vec3 _1369 = vec3(dot(_1362, _1353), dot(_1362, _1359), dot(_1362, _1356));
        float _1380 = 0.0039215688593685626983642578125;
        float _1382 = _1369.x;
        float _1385 = _1369.y;
        float _1388 = _1369.z;
        bool _1393 = _42(_1382, _1385, _1388) <= _1380;
        bool _1410;
        if (!_1393)
        {
            float _1397 = _1369.x;
            float _1400 = _1369.y;
            float _1403 = _1369.z;
            _1410 = _37(_1397, _1400, _1403) >= (1.0 - _1380);
        }
        else
        {
            _1410 = _1393;
        }
        if (_1410)
        {
            continue;
        }
        uint _1414 = _1195._m11;
        bool _1418 = _972 != 0u;
        bool _1425;
        if (_1418)
        {
            _1425 = (_1414 & 512u) != 0u;
        }
        else
        {
            _1425 = _1418;
        }
        bool _1438;
        if (!_1425)
        {
            bool _1430 = _972 == 0u;
            bool _1437;
            if (_1430)
            {
                _1437 = (_1414 & 1024u) != 0u;
            }
            else
            {
                _1437 = _1430;
            }
            _1438 = _1437;
        }
        else
        {
            _1438 = _1425;
        }
        if (_1438)
        {
            continue;
        }
        vec2 _1442 = vec2(dot(_1137, _1353.xyz), dot(_1137, _1359.xyz));
        vec2 _1452 = vec2(dot(_1141, _1353.xyz), dot(_1141, _1359.xyz));
        float _1462 = 1.0;
        float _1463 = 1.0;
        vec3 _1464 = vec3(0.5, 0.5, 1.0);
        vec3 _1467 = vec3(0.0, 0.0, 1.0);
        uint _1468 = _1195._m7;
        uint _1472 = _1195._m9;
        vec4 _1471 = _98(_1472);
        uvec2 _1477 = _1195._m5;
        vec4 _1476 = _111(_1477);
        vec2 _1481 = _1442 * _1476.xy;
        vec2 _1486 = _1452 * _1476.xy;
        vec2 _1501 = (_1369.xy * _1476.xy) + _1476.zw;
        vec2 _1502 = _1481;
        vec2 _1504 = _1486;
        vec4 _1491 = _128(_1492, _1501, _1502, _1504);
        vec2 _1507 = (_1491.xy * 2.0) - vec2(1.0);
        float _1518 = 1.0 - dot(_1507, _1507);
        _1464 = vec3(_1507, sqrt(_14(_1518)));
        _1467 = _1464;
        _1462 = _1491.z;
        if ((_1468 & 32u) == 0u)
        {
            float _1535 = _1462 - 0.5;
            _10(_1535);
        }
        float _1537 = _1491.w;
        _1463 = _60(_1537);
        bool _1544 = _1463 <= (4.0 * _1380);
        bool _1551;
        if (_1544)
        {
            _1551 = _1471.w <= _1380;
        }
        else
        {
            _1551 = _1544;
        }
        if (_1551)
        {
            continue;
        }
        _1464 = _1467;
        if ((_1414 & 128u) != 0u)
        {
            _1560 = vec3(-_1464.x, -_1464.y, _1464.z);
        }
        else
        {
            _1560 = _1464;
        }
        _1464 = _1560;
        uint _1575 = _1195._m8;
        uint _1579 = _1575;
        float _1578 = 1.0 + (_101(_1579).w * 0.062745101749897003173828125);
        uint _1587 = _1468;
        float _1586 = _98(_1587).z;
        uint _1592 = _1575;
        vec3 _1591 = _98(_1592).xyz;
        float _1605 = _1578 - (_1578 * abs((_1369.z * 2.0) - 1.0));
        _1463 *= _14(_1605);
        float _1609 = _1463;
        if ((_1468 & 1u) != 0u)
        {
            vec3 _1616 = _1591;
            _1591 = vec3(0.0);
            uvec2 _1619 = _1195._m3;
            vec4 _1618 = _111(_1619);
            vec2 _1623 = _1442 * _1618.xy;
            vec2 _1628 = _1452 * _1618.xy;
            vec2 _1642 = (_1369.xy * _1618.xy) + _1618.zw;
            vec2 _1643 = _1623;
            vec2 _1645 = _1628;
            vec4 _1633 = _128(_1492, _1642, _1643, _1645);
            vec4 _1648 = _1633;
            _1633 = _66(_1648);
            _1591 = _1633.xyz;
            float _1660 = (_1633.w - _1380) / (1.0 - _1380);
            _1609 = _14(_1660);
            _1591 *= _1616;
        }
        vec3 _1665 = normalize(vec3(_821._m17[0].z, _821._m17[1].z, _821._m17[2].z));
        float _1674 = dot(_1665, normalize(_1356.xyz));
        float _1680 = _1674;
        vec2 _1685 = _1464.xy * _80(_1680);
        _1464 = vec3(_1685.x, _1685.y, _1464.z);
        if ((_1414 & 16384u) != 0u)
        {
            float _1698 = abs(_1674);
            _1693 = _14(_1698);
        }
        else
        {
            float _1701 = _1674;
            _1693 = _14(_1701);
        }
        float _1688 = _1693;
        float _1705 = ((_1688 * _1609) * _1471.w) * _1586;
        _821._m10 += (_1471.xyz * (_1705 * 64.0));
        uint _1724 = _1195._m10;
        uint _1728 = _1724;
        vec4 _1727 = _98(_1728);
        if ((_1468 & 2u) != 0u)
        {
            uvec2 _1737 = _1195._m4;
            vec4 _1736 = _111(_1737);
            vec2 _1741 = _1442 * _1736.xy;
            vec2 _1746 = _1452 * _1736.xy;
            vec2 _1759 = (_1369.xy * _1736.xy) + _1736.zw;
            vec2 _1760 = _1741;
            vec2 _1762 = _1746;
            _1727 = _128(_1492, _1759, _1760, _1762);
            _1727 *= _1727;
        }
        if ((_1468 & 32u) != 0u)
        {
            uint _1774 = _1468;
            float _1773 = _98(_1774).x;
            uint _1779 = _1468;
            float _1778 = _101(_1779).y;
            float _1785 = _1773;
            float _1783 = mix(_1778, 0.0, _14(_1785));
            float _1794 = _1462 - (_1783 / 255.0);
            float _1789 = float(_14(_1794) > 0.0);
            _1463 *= _1789;
        }
        float _1801 = _1463 * _1688;
        uint _1805 = _1195._m6;
        uint _1809 = _1805;
        vec4 _1814 = _98(_1809) * _1801;
        vec4 _1808 = _26(_1814);
        _821._m11 = max(_821._m11, _1808.x);
        _821._m0 = mix(_821._m0, _1591, _1808.xxx);
        _821._m2 = mix(_821._m2, _1727.xyz, _1808.yyy);
        vec3 _1837 = _1665;
        vec3 _1847 = _1353.xyz + (_1837 * dot(_1353.xyz, _1837));
        _1353 = vec4(_1847.x, _1847.y, _1847.z, _1353.w);
        vec3 _1858 = _1359.xyz + (_1837 * dot(_1359.xyz, _1837));
        _1359 = vec4(_1858.x, _1858.y, _1858.z, _1359.w);
        _1464 = ((normalize(_1353.xyz) * _1464.x) + (normalize(_1359.xyz) * _1464.y)) + (_1837 * _1464.z);
        if ((_1414 & 256u) != 0u)
        {
            vec3 _1885 = mix(_1665, _1464, _1808.www);
            float _1891 = dot(_1885, _1665);
            _1464 = (_821._m6 * _1891) + ((_1885 - (_1665 * _1891)) * dot(_821._m6, _1665));
        }
        else
        {
            if ((_1414 & 64u) != 0u)
            {
                _1464 = mix(mix(_821._m6, _1665, vec3(_1801)), _1464, _1808.www);
            }
            else
            {
                _1464 = mix(_821._m6, _1464, _1808.www);
            }
        }
        _821._m6 = normalize(_1464);
        _821._m3 = mix(_821._m3, _1727.w, _1808.z);
    }
    vec3 _1945 = vec3(0.0);
    vec3 _1946 = vec3(_821._m34.x, _821._m34.y, _821._m34.z);
    vec3 _1954 = vec3(_821._m34.w, _821._m35.x, _821._m35.y);
    vec3 _1962 = vec3(_821._m35.z, _821._m35.w, _821._m36.x);
    vec3 _1970 = vec3(_821._m36.y, _821._m36.z, _821._m36.w);
    vec3 _1978 = ((_1946 - (_1954 * _821._m6.y)) + (_1962 * _821._m6.z)) - (_1970 * _821._m6.x);
    float _2001 = _975._m7.x * _842._m9.x;
    _1945 += max(_1978 * _14(_2001), vec3(0.0));
    float _2012;
    if (dot(_821._m10, vec3(1.0)) > 0.0)
    {
        _2012 = -_821._m3;
    }
    else
    {
        _2012 = _821._m3;
    }
    _821._m3 = _2012;
    _821._m18 = _1945;
    _821._m19 = _1945;
    float _2029 = 1.0;
    uint _2030 = _1074;
    _2060 _2062;
    while (_2030 < _1075)
    {
        uint _2040 = _1170._m0[_2030];
        uint _2044 = (_2040 >> uint(24)) & 4095u;
        uint _2048 = _2044;
        if (_2048 >= _2044)
        {
            _2030++;
        }
        int _2057 = 4;
        int _2058 = 4;
        int _2059 = 3;
        _2062._m0 = _2066._m0[(uint(_2057) * _2048) + 0u].xyz;
        float _2081 = _2066._m0[(uint(_2057) * _2048) + 0u].w;
        _2062._m1 = _31(_2081);
        _2062._m2 = _2066._m0[(uint(_2057) * _2048) + 1u];
        _2062._m3 = _2066._m0[(uint(_2057) * _2048) + 2u];
        _2062._m4 = _2105._m0[(uint(_2058) * _2048) + 0u];
        _2062._m5 = _2105._m0[(uint(_2058) * _2048) + 1u];
        _2062._m6 = _2105._m0[(uint(_2058) * _2048) + 2u];
        float _2135 = _2066._m0[(uint(_2057) * _2048) + 3u].x;
        _2062._m7.x = _31(_2135);
        float _2145 = _2066._m0[(uint(_2057) * _2048) + 3u].y;
        _2062._m7.y = _31(_2145);
        float _2155 = _2066._m0[(uint(_2057) * _2048) + 3u].z;
        _2062._m7.z = _31(_2155);
        float _2165 = _2066._m0[(uint(_2057) * _2048) + 3u].w;
        _2062._m7.w = _31(_2165);
        _2062._m8 = _2174._m0[(uint(_2059) * _2048) + 0u];
        _2062._m9 = _2174._m0[(uint(_2059) * _2048) + 1u];
        _2062._m10 = _2174._m0[(uint(_2059) * _2048) + 2u];
        float _2204 = _2105._m0[(uint(_2058) * _2048) + 3u].x;
        _2062._m11 = _31(_2204);
        float _2214 = _2105._m0[(uint(_2058) * _2048) + 3u].y;
        _2062._m12 = _31(_2214);
        _2062._m13 = _2105._m0[(uint(_2058) * _2048) + 3u].z;
        float _2232 = _2105._m0[(uint(_2058) * _2048) + 3u].w;
        _2062._m14 = _31(_2232);
        vec3 _2237 = vec3((_821._m14.x * _2062._m4.x) + ((_821._m14.y * _2062._m4.y) + ((_821._m14.z * _2062._m4.z) + _2062._m4.w)), (_821._m14.x * _2062._m5.x) + ((_821._m14.y * _2062._m5.y) + ((_821._m14.z * _2062._m5.z) + _2062._m5.w)), (_821._m14.x * _2062._m6.x) + ((_821._m14.y * _2062._m6.y) + ((_821._m14.z * _2062._m6.z) + _2062._m6.w)));
        vec2 _2304 = _2237.xy / vec2(_2237.z);
        _2237 = vec3(_2304.x, _2304.y, _2237.z);
        _2237.z = (_821._m14.x * _2062._m3.x) + ((_821._m14.y * _2062._m3.y) + ((_821._m14.z * _2062._m3.z) + _2062._m3.w));
        float _2328 = 0.0039215688593685626983642578125;
        float _2329 = _2237.x;
        float _2332 = _2237.y;
        float _2335 = _2237.z;
        bool _2340 = _42(_2329, _2332, _2335) < _2328;
        bool _2357;
        if (!_2340)
        {
            float _2344 = _2237.x;
            float _2347 = _2237.y;
            float _2350 = _2237.z;
            _2357 = _37(_2344, _2347, _2350) >= (1.0 - _2328);
        }
        else
        {
            _2357 = _2340;
        }
        if (_2357)
        {
            continue;
        }
        uint _2361 = _2062._m1;
        uint _2365 = _2062._m12;
        vec3 _2364 = _131(_2365);
        float _2369 = _2062._m13;
        vec3 _2372 = _2062._m0;
        uint _2376 = _2361;
        float _2375 = _98(_2376).y;
        vec3 _2380 = (_2237 * 2.0) - vec3(1.0);
        vec3 _2384 = _2380 * sqrt(((vec3(1.0) - ((_2380.yzx * _2380.yzx) * 0.5)) - ((_2380.zxy * _2380.zxy) * 0.5)) + ((((_2380.yzx * _2380.yzx) * _2380.zxy) * _2380.zxy) / vec3(3.0)));
        float _2428 = 1.0 - ((length(_2384) - _2375) / ((1.0 - _2375) + 9.9999999747524270787835121154785e-07));
        float _2417 = _14(_2428);
        _2417 *= _2417;
        _2417 *= (_2062._m8.w * _2029);
        _2029 *= (1.0 - _2417);
        if (_2417 <= (_2328 * 4.0))
        {
            continue;
        }
        vec3 _2450 = _2364;
        uint _2453 = _2361;
        float _2452 = _101(_2453).z;
        vec3 _2457 = vec3(0.0);
        vec3 _2458 = vec3(0.0);
        vec3 _2459 = _821._m6;
        _2459.x = dot(_2062._m2.xy, _821._m6.xy);
        _2459.y = dot(_2062._m2.zw, _821._m6.xy);
        vec3 _2478 = reflect(-_821._m13, _821._m6);
        vec3 _2485 = (_2062._m9.xyz - _821._m14) / _2478;
        vec3 _2494 = (_2062._m8.xyz - _821._m14) / _2478;
        vec3 _2503 = max(_2485, _2494);
        float _2508 = _2503.x;
        float _2511 = _2503.y;
        float _2514 = _2503.z;
        float _2507 = _42(_2508, _2511, _2514);
        vec3 _2518 = _821._m14 + (_2478 * _2507);
        vec3 _2525 = normalize(_2518 - _2372);
        vec3 _2530 = _2525;
        _2530.x = dot(_2062._m2.xy, _2525.xy);
        _2530.y = dot(_2062._m2.zw, _2525.xy);
        float _2552 = dot(_821._m13, _821._m6);
        float _2546 = _14(_2552);
        float _2554 = 0.0;
        float _2555 = 6.0;
        float _2557 = max(_2554, _2555 - (_2555 * abs(_821._m3)));
        _2458 = textureLod(_2570, vec4(_2530, _2452), _2557).xyz * _2369;
        float _2587 = _2546;
        float _2589 = abs(_821._m3);
        vec3 _2590 = _821._m2;
        vec3 _2583 = _150(_2587, _2589, _2590);
        _2458 *= _2583;
        float _2601 = _2417;
        _821._m20 += ((_2458 * _2450) * _14(_2601));
        if (_2029 <= (_2328 * 4.0))
        {
            break;
        }
    }
    uint _2616 = _1070;
    _2060 _2645;
    vec3 _2929;
    float _3006;
    float _3024;
    _3394 _3396;
    uint _3517;
    _3394 _3541;
    vec3 _4015;
    vec3 _4028;
    while (_2616 < _1071)
    {
        uint _2626 = _1170._m0[_2616];
        uint _2630 = _2626 & 4095u;
        uint _2633 = _2630;
        if (_2633 >= _2630)
        {
            _2616++;
        }
        int _2642 = 4;
        int _2643 = 4;
        int _2644 = 3;
        _2645._m0 = _2066._m0[(uint(_2642) * _2633) + 0u].xyz;
        float _2660 = _2066._m0[(uint(_2642) * _2633) + 0u].w;
        _2645._m1 = _31(_2660);
        _2645._m2 = _2066._m0[(uint(_2642) * _2633) + 1u];
        _2645._m3 = _2066._m0[(uint(_2642) * _2633) + 2u];
        _2645._m4 = _2105._m0[(uint(_2643) * _2633) + 0u];
        _2645._m5 = _2105._m0[(uint(_2643) * _2633) + 1u];
        _2645._m6 = _2105._m0[(uint(_2643) * _2633) + 2u];
        float _2710 = _2066._m0[(uint(_2642) * _2633) + 3u].x;
        _2645._m7.x = _31(_2710);
        float _2720 = _2066._m0[(uint(_2642) * _2633) + 3u].y;
        _2645._m7.y = _31(_2720);
        float _2730 = _2066._m0[(uint(_2642) * _2633) + 3u].z;
        _2645._m7.z = _31(_2730);
        float _2740 = _2066._m0[(uint(_2642) * _2633) + 3u].w;
        _2645._m7.w = _31(_2740);
        _2645._m8 = _2174._m0[(uint(_2644) * _2633) + 0u];
        _2645._m9 = _2174._m0[(uint(_2644) * _2633) + 1u];
        _2645._m10 = _2174._m0[(uint(_2644) * _2633) + 2u];
        float _2774 = _2105._m0[(uint(_2643) * _2633) + 3u].x;
        _2645._m11 = _31(_2774);
        float _2784 = _2105._m0[(uint(_2643) * _2633) + 3u].y;
        _2645._m12 = _31(_2784);
        _2645._m13 = _2105._m0[(uint(_2643) * _2633) + 3u].z;
        float _2802 = _2105._m0[(uint(_2643) * _2633) + 3u].w;
        _2645._m14 = _31(_2802);
        float _2807 = 0.0039215688593685626983642578125;
        vec4 _2808 = vec4(_821._m14, 1.0);
        float _2815 = 1.0 / dot(_2808, _2645._m6);
        vec3 _2821 = vec3(dot(_2808, _2645._m4) * _2815, dot(_2808, _2645._m5) * _2815, dot(_2808, _2645._m3));
        uint _2839 = _2645._m1;
        uint _2842 = _972;
        _2842 |= 64u;
        float _2846 = _2821.x;
        float _2849 = _2821.y;
        float _2852 = _2821.z;
        bool _2857 = _42(_2846, _2849, _2852) <= _2807;
        bool _2874;
        if (!_2857)
        {
            float _2861 = _2821.x;
            float _2864 = _2821.y;
            float _2867 = _2821.z;
            _2874 = _37(_2861, _2864, _2867) >= (1.0 - _2807);
        }
        else
        {
            _2874 = _2857;
        }
        bool _2882;
        if (!_2874)
        {
            _2882 = (_2839 & _2842) != 0u;
        }
        else
        {
            _2882 = _2874;
        }
        if (_2882)
        {
            continue;
        }
        if ((_2839 & 3u) == 2u)
        {
            vec2 _2901 = fract((_2821.xy * _842._m10.xy) + _842._m10.zw);
            _2821 = vec3(_2901.x, _2901.y, _2821.z);
        }
        vec3 _2904 = _2645._m0;
        float _2907 = 1.0;
        float _2908 = 1.0;
        vec3 _2909 = vec3(0.0, 0.0, 1.0);
        vec3 _2910 = vec3(0.0, 0.0, 1.0);
        uint _2911 = _2645._m1;
        vec3 _2914 = (_2821 * 2.0) - vec3(1.0);
        vec2 _2919 = _2821.xy;
        vec3 _2922 = _2645._m10.xyz;
        if ((_2911 & 3u) == 2u)
        {
            _2929 = _2922;
        }
        else
        {
            _2929 = normalize(_2904 - _821._m14);
        }
        _2909 = _2929;
        _2909 = _2909;
        float _2946 = dot(_821._m6, _2909);
        float _2941 = _14(_2946);
        uvec2 _2949 = _2645._m7.zw;
        vec4 _2948 = _111(_2949);
        float _2955 = TEXTURE_LOD(_2956, vec4((_2919 * _2948.xy) + _2948.zw, 0.0, 0.0).xy, vec4((_2919 * _2948.xy) + _2948.zw, 0.0, 0.0).w).x;
        float _2982 = _2955 * _2955;
        uint _2986 = _2911 & 3u;
        bool _2991 = _2986 == 1u;
        bool _3003;
        if (!_2991)
        {
            bool _2996 = _2986 == 0u;
            bool _3002;
            if (_2996)
            {
                _3002 = _2645._m8.z != 0.0;
            }
            else
            {
                _3002 = _2996;
            }
            _3003 = _3002;
        }
        else
        {
            _3003 = _2991;
        }
        bool _2989 = _3003;
        if (_2989)
        {
            float _3009 = _2645._m8.w;
            _3006 = _14(_3009);
        }
        else
        {
            _3006 = 0.5;
        }
        float _3004 = _3006;
        bool _3017 = _2986 == 0u;
        bool _3023;
        if (_3017)
        {
            _3023 = _2645._m8.z != 0.0;
        }
        else
        {
            _3023 = _3017;
        }
        if (_3023)
        {
            float _3032 = sqrt(dot(_2914, _2914));
            _3024 = min(0.9921875, _14(_3032));
        }
        else
        {
            _3024 = _2821.z;
        }
        float _3015 = _3024;
        uvec2 _3040 = _2645._m7.xy;
        vec4 _3039 = _111(_3040);
        vec2 _3045 = vec2(_3015, _3004);
        float _3049 = TEXTURE_LOD(_2956, vec4((_3045 * _3039.xy) + _3039.zw, 0.0, 0.0).xy, vec4((_3045 * _3039.xy) + _3039.zw, 0.0, 0.0).w).x;
        _3049 *= _3049;
        _2907 = _3049 * _2982;
        if ((_2911 & 48u) != 0u)
        {
            vec4 _3087 = _2645._m10;
            vec4 _3090 = _2645._m8;
            vec4 _3093 = _2645._m9;
            float _3096 = dot(_821._m14, _3087.xyz) + _3087.w;
            if (_3096 < 0.0)
            {
                continue;
            }
            float _3110 = length(_3087.xyz);
            float _3117 = _3096 * 50.0;
            float _3114 = _14(_3117);
            _2907 *= (_3114 * _3114);
            _3096 /= _3110;
            _3087 /= vec4(_3110);
            vec3 _3131 = reflect(-_821._m13, _821._m6);
            if (dot(_3131, _3087.xyz) > 0.0)
            {
                _3131 = reflect(_3131, _3087.xyz);
            }
            float _3149 = dot(_3131, _3087.xyz);
            float _3154 = _3096 / _3149;
            vec3 _3158 = _821._m14 - (_3131 * _3154);
            vec3 _3165 = _3158 - _2904;
            float _3169 = dot(_3165, _3090.xyz) / _3090.w;
            float _3177 = dot(_3165, _3093.xyz) / _3093.w;
            if ((_2911 & 48u) == 32u)
            {
                vec2 _3190 = vec2(_3169, _3177);
                float _3194 = 1.0 / max(1.0, length(vec2(_3169, _3177)));
                _3169 *= (_3194 * _3090.w);
                _3177 *= (_3194 * _3093.w);
            }
            else
            {
                float _3216 = abs(_3169);
                float _3218 = _3169;
                _3169 = (_14(_3216) * _80(_3218)) * _3090.w;
                float _3227 = abs(_3177);
                float _3229 = _3177;
                _3177 = (_14(_3227) * _80(_3229)) * _3093.w;
            }
            vec3 _3236 = (_3090.xyz * _3169) + (_3093.xyz * _3177);
            _2904 += _3236;
            _2909 = normalize(_2904 - _821._m14);
            _2909 = _2909;
        }
        else
        {
            uint _3256 = (_2645._m14 >> uint(16)) & 255u;
            if (_3256 == 0u)
            {
                vec4 _3265 = _2645._m9;
                if (dot(_3265.xyz, _821._m14) < (_3265.w - _2807))
                {
                    continue;
                }
            }
            else
            {
                if (_3256 == 1u)
                {
                    vec3 _3286 = _2645._m9.xyz;
                    float _3291 = _2645._m9.w;
                    uint _3295 = _31(_3291);
                    vec3 _3290 = (((_105(_3295) * 2.0) - vec3(1.0)) * _3286) + _2904;
                    vec3 _3304 = abs((_821._m14 - _3290) / _3286);
                    float _3312 = _3304.x;
                    float _3315 = _3304.y;
                    float _3318 = _3304.z;
                    if (_37(_3312, _3315, _3318) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2907 <= (_2807 / 256.0))
        {
            continue;
        }
        float _3334 = 1.0;
        if ((_2839 & 4u) != 0u)
        {
            float _3341 = float(_2645._m14 & 255u) / 255.0;
            float _3347 = 0.00999999977648258209228515625;
            vec3 _3349 = _821._m14 + (_821._m6 * _3347);
            uint _3357 = 0u;
            if ((_2839 & 3u) == 0u)
            {
                vec3 _3363 = _3349 - _2645._m2.xyz;
                float _3369 = _3363.x;
                float _3372 = _3363.y;
                float _3375 = _3363.z;
                _3357 = _48(_3369, _3372, _3375);
            }
            else
            {
                if ((_2839 & 3u) == 2u)
                {
                    float _3385 = 0.0;
                    for (; _3357 < 3u; _3357++)
                    {
                        int _3393 = 5;
                        _3396._m0 = _3400._m0[(uint(_3393) * ((_2839 >> uint(22)) + _3357)) + 0u];
                        _3396._m1 = _3400._m0[(uint(_3393) * ((_2839 >> uint(22)) + _3357)) + 1u];
                        _3396._m2 = _3400._m0[(uint(_3393) * ((_2839 >> uint(22)) + _3357)) + 2u];
                        _3396._m3 = _3400._m0[(uint(_3393) * ((_2839 >> uint(22)) + _3357)) + 3u];
                        _3396._m4 = _3400._m0[(uint(_3393) * ((_2839 >> uint(22)) + _3357)) + 4u];
                        vec2 _3457 = vec2(dot(_3349, _3396._m0.xyz) + _3396._m0.w, dot(_3349, _3396._m1.xyz) + _3396._m1.w);
                        _3457 = abs((_3457 * 2.0) - vec2(1.0));
                        bool _3482 = _3457.x < 1.0;
                        bool _3488;
                        if (_3482)
                        {
                            _3488 = _3457.y < 1.0;
                        }
                        else
                        {
                            _3488 = _3482;
                        }
                        if (_3488)
                        {
                            _3385 = (1.0 - max(_3457.x, _3457.y)) * _842._m11.w;
                            break;
                        }
                    }
                    _3357 = min(2u, _3357);
                    uint _3505 = uint(_821._m16.x) ^ (uint(_821._m16.y) << uint(1));
                    if (_842._m12.w > 0.0)
                    {
                        _3517 = uint(_842._m13.x);
                    }
                    else
                    {
                        _3517 = 0u;
                    }
                    _3505 ^= _3517;
                    _3357 += uint(int(((float(_3505 & 3u) * 0.25) + 0.125) > _3385));
                }
            }
            int _3540 = 5;
            _3541._m0 = _3400._m0[(uint(_3540) * ((_2839 >> uint(22)) + _3357)) + 0u];
            _3541._m1 = _3400._m0[(uint(_3540) * ((_2839 >> uint(22)) + _3357)) + 1u];
            _3541._m2 = _3400._m0[(uint(_3540) * ((_2839 >> uint(22)) + _3357)) + 2u];
            _3541._m3 = _3400._m0[(uint(_3540) * ((_2839 >> uint(22)) + _3357)) + 3u];
            _3541._m4 = _3400._m0[(uint(_3540) * ((_2839 >> uint(22)) + _3357)) + 4u];
            vec4 _3597 = vec4((_3349.x * _3541._m0.x) + ((_3349.y * _3541._m0.y) + ((_3349.z * _3541._m0.z) + _3541._m0.w)), (_3349.x * _3541._m1.x) + ((_3349.y * _3541._m1.y) + ((_3349.z * _3541._m1.z) + _3541._m1.w)), (_3349.x * _3541._m2.x) + ((_3349.y * _3541._m2.y) + ((_3349.z * _3541._m2.z) + _3541._m2.w)), (_3349.x * _3541._m3.x) + ((_3349.y * _3541._m3.y) + ((_3349.z * _3541._m3.z) + _3541._m3.w)));
            vec3 _3684 = _3597.xyz / vec3(_3597.w);
            _3597 = vec4(_3684.x, _3684.y, _3684.z, _3597.w);
            bool _3692 = min(_3597.x, _3597.y) > 0.0;
            bool _3701;
            if (_3692)
            {
                _3701 = max(_3597.x, _3597.y) < 1.0;
            }
            else
            {
                _3701 = _3692;
            }
            if (_3701)
            {
                vec2 _3713 = (_3597.xy * _3541._m4.xy) + _3541._m4.zw;
                _3597 = vec4(_3713.x, _3713.y, _3597.z, _3597.w);
                if (false)
                {
                    _3334 = textureLod(_3721, vec3(_3597.xyz.xy, _3597.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3728 = (_3597.xy * _842._m14.xy) + vec2(0.5);
                    vec2 _3737 = floor(_3728);
                    vec2 _3740 = _3728 - _3737;
                    _3737 -= vec2(0.5);
                    vec2 _3747 = vec2(4.0) - (_3740 * 3.0);
                    vec2 _3752 = vec2(7.0);
                    vec2 _3755 = vec2(1.0) + (_3740 * 3.0);
                    vec2 _3760 = (_3737 + (((vec2(3.0) - (_3740 * 2.0)) / _3747) - vec2(2.0))) * _842._m14.zw;
                    vec2 _3775 = (_3737 + ((vec2(3.0) + _3740) / _3752)) * _842._m14.zw;
                    vec2 _3787 = (_3737 + ((_3740 / _3755) + vec2(2.0))) * _842._m14.zw;
                    vec3 _3811 = vec3(_3760.x, _3760.y, _3597.z);
                    _3334 = (_3747.x * _3747.y) * textureLod(_3721, vec3(_3811.xy, _3811.z), 0.0);
                    vec3 _3827 = vec3(_3775.x, _3760.y, _3597.z);
                    _3334 += ((_3752.x * _3747.y) * textureLod(_3721, vec3(_3827.xy, _3827.z), 0.0));
                    vec3 _3845 = vec3(_3787.x, _3760.y, _3597.z);
                    _3334 += ((_3755.x * _3747.y) * textureLod(_3721, vec3(_3845.xy, _3845.z), 0.0));
                    vec3 _3863 = vec3(_3760.x, _3775.y, _3597.z);
                    _3334 += ((_3747.x * _3752.y) * textureLod(_3721, vec3(_3863.xy, _3863.z), 0.0));
                    vec3 _3881 = vec3(_3775.x, _3775.y, _3597.z);
                    _3334 += ((_3752.x * _3752.y) * textureLod(_3721, vec3(_3881.xy, _3881.z), 0.0));
                    vec3 _3899 = vec3(_3787.x, _3775.y, _3597.z);
                    _3334 += ((_3755.x * _3752.y) * textureLod(_3721, vec3(_3899.xy, _3899.z), 0.0));
                    vec3 _3917 = vec3(_3760.x, _3787.y, _3597.z);
                    _3334 += ((_3747.x * _3755.y) * textureLod(_3721, vec3(_3917.xy, _3917.z), 0.0));
                    vec3 _3935 = vec3(_3775.x, _3787.y, _3597.z);
                    _3334 += ((_3752.x * _3755.y) * textureLod(_3721, vec3(_3935.xy, _3935.z), 0.0));
                    vec3 _3953 = vec3(_3787.x, _3787.y, _3597.z);
                    _3334 += ((_3755.x * _3755.y) * textureLod(_3721, vec3(_3953.xy, _3953.z), 0.0));
                    _3334 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3334 = float((_2839 & 3u) == 2u);
            }
            float _3967 = float((_2839 >> uint(16)) & 63u) / 63.0;
            float _3981 = ((_3334 * _3967) + 1.0) - _3967;
            _3334 = _14(_3981);
        }
        uint _3984 = _2645._m12;
        vec3 _3983 = (_131(_3984) * _3334) * _2907;
        _2908 *= _2645._m13;
        vec3 _3996 = _3983;
        vec3 _3998 = normalize(_2904 - _821._m14);
        float _4004 = dot(_821._m6, _3998);
        float _4010 = _4004;
        float _4009 = _80(_4010);
        if (_4009 >= 0.0)
        {
            _4015 = _3998;
        }
        else
        {
            _4015 = reflect(_3998, _821._m6);
        }
        _3998 = _4015;
        if (_4009 >= 0.0)
        {
            _4028 = vec3(1.0);
        }
        else
        {
            _4028 = _821._m0;
        }
        vec3 _4025 = _4028;
        float _4039 = dot(_821._m6, _3998);
        float _4041 = _4004;
        _4004 = mix(_14(_4039), _14(_4041), _821._m11);
        _821._m19 += (_3996 * _4004);
        vec3 _4055 = _821._m6;
        vec3 _4058 = _821._m13;
        vec3 _4061 = _3998;
        vec3 _4063 = _821._m2;
        float _4066 = _821._m3;
        vec3 _4054 = _144(_4055, _4058, _4061, _4063, _4066);
        vec3 _4070 = ((((_3996 * _4004) * _4054) * _2908) * _4025) + _821._m20;
        vec3 _4083 = vec3(40.0);
        _821._m20 = min(_4070, _4083);
    }
    _821._m19 = _821._m19;
    _821._m20 += _821._m10;
    _821._m19 *= _821._m0;
    _821._m21 = _821._m19 + _821._m20;
    _821._m21 = (_821._m19 * _821._m11) + _821._m20;
    _4121 = vec4(_821._m21, _821._m11);
    vec2 _4130 = _821._m16.xy * _842._m6.zw;
    float _4138 = _821._m16.z;
    vec4 _4141 = vec4(0.0);
    float _4142 = 1.0;
    float _4144 = _842._m15.w;
    uint _4143 = _31(_4144);
    if ((_4143 & 6u) != 0u)
    {
        vec2 _4154 = _4130 + vec2(0.0);
        vec3 _4158 = _842._m16.xyz;
        float _4162 = 0.100000001490116119384765625;
        float _4164 = _842._m17.y;
        float _4167 = _842._m16.z;
        float _4170 = 0.0;
        float _4172 = _4138;
        vec4 _4174 = _842._m7;
        float _4177 = 1.0;
        bool _4178 = false;
        float _4171 = _159(_4172, _4174, _4177, _4178);
        _4170 = pow((_4171 - _4162) / (_4164 - _4162), 0.5);
        _4170 = (_4170 * (_4167 - 1.0)) / _4167;
        vec4 _4194 = vec4(_4154, _4170, 0.0);
        vec3 _4220 = textureLod(_4203, vec4(_4194.xyz, 0.0).xyz, vec4(_4194.xyz, 0.0).w).xyz;
        _4141 = vec4(_4220.x, _4220.y, _4220.z, _4141.w);
        vec2 _4223 = textureLod(_4224, vec4(_4194.xyz, 0.0).xyz, vec4(_4194.xyz, 0.0).w).xy;
        _4141.w = _4223.x;
        _4142 = _4223.y;
    }
    if ((_4143 & 2u) != 0u)
    {
        vec4 _4252 = vec4(0.0);
        vec3 _4253 = _842._m4.xyz;
        float _4258 = _4138;
        vec4 _4260 = _842._m7;
        float _4263 = 1.0;
        bool _4264 = false;
        float _4257 = _159(_4258, _4260, _4263, _4264);
        vec3 _4266 = mix(_842._m18.xyz, _842._m19.xyz, vec3(_4130.x * _842._m20.z));
        vec3 _4280 = mix(_842._m21.xyz, _842._m22.xyz, vec3(_4130.x * _842._m20.z));
        vec3 _4294 = mix(_4280, _4266, vec3(1.0 - (_4130.y * _842._m20.w)));
        vec4 _4305 = vec4(0.0);
        vec3 _4306 = normalize(_4294);
        float _4309 = _4306.z;
        _4305.x = clamp(_83(_4309) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _4318 = _4306.y;
        float _4321 = _4306.x;
        _4305.y = _93(_4318, _4321) / 6.283185482025146484375;
        _4305.z = sqrt(_4257 * _842._m23.w);
        _4305.z = clamp(_4305.z, 0.015625, 0.984375);
        vec3 _4348 = textureLod(_4341, _4305.xyz, _4305.w).xyz;
        _4252 = vec4(_4348.x, _4348.y, _4348.z, _4252.w);
        _4252 *= _4121.w;
        vec3 _4362 = _4121.xyz + (_4252.xyz * _4142);
        _4121 = vec4(_4362.x, _4362.y, _4362.z, _4121.w);
    }
    if ((_4143 & 4u) != 0u)
    {
        vec3 _4374 = _4141.xyz * _4121.w;
        _4141 = vec4(_4374.x, _4374.y, _4374.z, _4141.w);
        vec3 _4384 = (_4121.xyz * _4141.w) + _4141.xyz;
        _4121 = vec4(_4384.x, _4384.y, _4384.z, _4121.w);
    }
    vec3 _4392 = _4121.xyz + _975._m8.xyz;
    _4121 = vec4(_4392.x, _4392.y, _4392.z, _4121.w);
    _4395 = vec4(0.0);
    _4396 = vec4(0.0);
    if (_842._m24.w > 0.0)
    {
        vec2 _4402 = gl_FragCoord.xy * _842._m6.xy;
        bool _4409 = (gl_FragCoord.z < TEXTURE_LOD(_4413, vec4(_4402, 0.0, 0.0).xy, vec4(_4402, 0.0, 0.0).w).x) ? true : false;
        if (_4409 == false)
        {
            _4395 = _4121;
        }
        _4121 *= float(_4409 == true);
        _4396.x = _4121.w;
    }
}


