// GEOMETRY
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _20
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 1, std430) restrict readonly buffer _22_24
{
    _20 _m0[];
} _24;

layout(set = 2, binding = 0, std140) uniform _66_68
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _68;

layout(set = 0, binding = 0, std140) uniform _78_80
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _80;

layout(set = 1, binding = 0, std140) uniform _132_134
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _134;

layout(set = 0, binding = 2, std430) restrict readonly buffer _349_351
{
    vec4 _m0[];
} _351;

layout(push_constant, std430) uniform _27_29
{
    int _m0;
    int _m1;
} _29;

layout(set = 0, binding = 3) uniform sampler _569;

layout(location = 0) in vec4 _56;
layout(location = 3) in vec4 _117;
layout(location = 9) in vec4 _369;
layout(location = 2) in vec4 _385;
layout(location = 1) in vec2 _544;
layout(location = 12) in vec2 _546;
layout(location = 2) out vec4 _554;
layout(location = 14) flat out uvec3 _561;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    vec4 _19 = _24._m0[_29._m1]._m0;
    vec4 _37 = _24._m0[_29._m1]._m1;
    vec4 _42 = _24._m0[_29._m1]._m2;
    vec4 _48 = _24._m0[_29._m1]._m3;
    vec4 _54 = vec4(_56.xyz, 1.0);
    bool _75 = _68._m0.x != 0.0;
    bool _86;
    if (_75)
    {
        _86 = _80._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _86 = _75;
    }
    bool _92;
    if (_86)
    {
        _92 = _68._m1.x > 0.0;
    }
    else
    {
        _92 = _86;
    }
    if (_92)
    {
        vec3 _96 = vec3(_80._m0.xy, 0.0);
        float _105 = _68._m0.x;
        float _108 = _68._m0.y;
        float _112 = _68._m0.w;
        vec4 _116 = _117;
        float _119 = _68._m1.x;
        float _122 = _68._m1.y;
        float _125 = _68._m1.z;
        float _128 = _68._m1.w;
        vec4 _135 = _54;
        vec4 _137 = _134._m0;
        vec4 _131;
        _131.x = _12(_135, _137);
        vec4 _142 = _54;
        vec4 _144 = _134._m1;
        _131.y = _12(_142, _144);
        vec4 _149 = _54;
        vec4 _151 = _134._m2;
        _131.z = _12(_149, _151);
        _131.w = 1.0;
        float _157 = dot(_131.xyz, _96) * _119;
        float _164 = _116.z * _128;
        float _169 = _134._m0.w * _134._m1.w;
        float _175 = ((_80._m1.x * _68._m0.z) * _119) - _157;
        float _185 = (_116.x * 1.0) - _164;
        float _191 = sin(_175 - _185);
        float _196 = sin((_175 * 1.33000004291534423828125) - _185);
        float _203 = ((_191 + _196) * 0.25) + 0.5;
        _203 *= _203;
        float _214 = (_203 * (_108 - _105)) + _105;
        vec3 _222 = _96 * vec3(_214);
        float _227 = ((_116.y * 16.0) - _169) - _164;
        float _236 = sin(((_80._m1.x * 4.0) * _122) + _227);
        float _246 = cos(((_80._m1.x * 3.3299999237060546875) * _122) + _227);
        float _256 = (_236 + _246) * (-_116.w);
        vec3 _264 = vec3(_236 * _112, _246 * _112, _256 * _125) * vec3(_214);
        vec3 _278 = ((_222 + _264) * _80._m0.z) * _116.z;
        vec3 _291 = _131.xyz + _278;
        _131 = vec4(_291.x, _291.y, _291.z, _131.w);
        _131.w = 1.0;
        _54.x = dot(_131, _134._m3);
        _54.y = dot(_131, _134._m4);
        _54.z = dot(_131, _134._m5);
    }
    if (_68._m2.z != 0.0)
    {
        vec4 _317 = _54;
        vec4 _319 = vec4(0.0);
        vec4 _321 = vec4(0.0);
        vec4 _322 = vec4(0.0);
        uvec4 _325 = uvec4(uint(_134._m6.x + _68._m2.x)) + uvec4(_117 * 255.0);
        if (_68._m2.z == 1.0)
        {
            uint _345 = _325.x;
            _319 = _351._m0[(_345 * 3u) + 0u];
            _321 = _351._m0[(_345 * 3u) + 1u];
            _322 = _351._m0[(_345 * 3u) + 2u];
        }
        else
        {
            float _368 = _369.w * 255.100006103515625;
            vec4 _375;
            _375.y = _368 - (floor(_368 / 128.0) * 128.0);
            float _384 = _385.w * 255.100006103515625;
            _375.z = floor(_384 / 16.0);
            _375.w = _384 - (_375.z * 16.0);
            _375.y *= 0.00393700785934925079345703125;
            _375.z *= 0.02222222276031970977783203125;
            _375.w *= 0.01666666753590106964111328125;
            _375.x = 1.0 - ((_375.y + _375.z) + _375.w);
            for (uint _424 = 0u; _424 < 4u; _424++)
            {
                _319 += (_351._m0[(_325[_424] * 3u) + 0u] * _375[_424]);
            }
            for (uint _448 = 0u; _448 < 4u; _448++)
            {
                _321 += (_351._m0[(_325[_448] * 3u) + 1u] * _375[_448]);
            }
            for (uint _471 = 0u; _471 < 4u; _471++)
            {
                _322 += (_351._m0[(_325[_471] * 3u) + 2u] * _375[_471]);
            }
        }
        vec4 _494 = _317;
        vec4 _496 = _319;
        _54.x = _12(_494, _496);
        vec4 _500 = _317;
        vec4 _502 = _321;
        _54.y = _12(_500, _502);
        vec4 _506 = _317;
        vec4 _508 = _322;
        _54.z = _12(_506, _508);
        _54.w = 1.0;
    }
    vec4 _517 = _54;
    vec4 _519 = _19;
    gl_Position.x = _12(_517, _519);
    vec4 _524 = _54;
    vec4 _526 = _37;
    gl_Position.y = _12(_524, _526);
    vec4 _530 = _54;
    vec4 _532 = _42;
    gl_Position.z = _12(_530, _532);
    vec4 _536 = _54;
    vec4 _538 = _48;
    gl_Position.w = _12(_536, _538);
    vec4 _542 = vec4(_544, _546);
    _554 = _542 + _68._m3;
    _561 = uvec3(0u);
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


