
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 1, binding = 0, std140) uniform _32_34
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _34;

layout(set = 0, binding = 0, std140) uniform _73_75
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _75;

layout(set = 2, binding = 0, std140) uniform _134_136
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _136;

layout(set = 0, binding = 1, std430) restrict readonly buffer _411_413
{
    vec4 _m0[];
} _413;

layout(push_constant, std430) uniform _629_631
{
    int _m0;
    int _m1;
} _631;

layout(set = 0, binding = 2) uniform sampler _634;

layout(location = 0) in vec4 _125;
layout(location = 3) in vec4 _182;
layout(location = 9) in vec4 _431;
layout(location = 2) in vec4 _447;
layout(location = 1) in vec2 _606;
layout(location = 12) in vec2 _608;
layout(location = 2) out vec4 _616;
layout(location = 14) flat out uvec3 _623;

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

void main()
{
    mat4 _31 = mat4(vec4(_34._m0), vec4(_34._m1), vec4(_34._m2), vec4(_34._m3));
    mat4 _72 = mat4(vec4(_75._m0), vec4(_75._m1), vec4(_75._m2), vec4(_75._m3));
    mat4 _106 = _31;
    mat4 _108 = _72;
    mat4 _105 = _19(_106, _108);
    vec4 _111 = _105[0];
    vec4 _114 = _105[1];
    vec4 _117 = _105[2];
    vec4 _120 = _105[3];
    vec4 _123 = vec4(_125.xyz, 1.0);
    bool _142 = _136._m0.x != 0.0;
    bool _151;
    if (_142)
    {
        _151 = _75._m4.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _151 = _142;
    }
    bool _157;
    if (_151)
    {
        _157 = _136._m1.x > 0.0;
    }
    else
    {
        _157 = _151;
    }
    if (_157)
    {
        vec3 _161 = vec3(_75._m4.xy, 0.0);
        float _170 = _136._m0.x;
        float _173 = _136._m0.y;
        float _177 = _136._m0.w;
        vec4 _181 = _182;
        float _184 = _136._m1.x;
        float _187 = _136._m1.y;
        float _190 = _136._m1.z;
        float _193 = _136._m1.w;
        vec4 _197 = _123;
        vec4 _199 = _34._m0;
        vec4 _196;
        _196.x = _12(_197, _199);
        vec4 _204 = _123;
        vec4 _206 = _34._m1;
        _196.y = _12(_204, _206);
        vec4 _211 = _123;
        vec4 _213 = _34._m2;
        _196.z = _12(_211, _213);
        _196.w = 1.0;
        float _219 = dot(_196.xyz, _161) * _184;
        float _226 = _181.z * _193;
        float _231 = _34._m0.w * _34._m1.w;
        float _237 = ((_75._m5.x * _136._m0.z) * _184) - _219;
        float _248 = (_181.x * 1.0) - _226;
        float _254 = sin(_237 - _248);
        float _259 = sin((_237 * 1.33000004291534423828125) - _248);
        float _266 = ((_254 + _259) * 0.25) + 0.5;
        _266 *= _266;
        float _277 = (_266 * (_173 - _170)) + _170;
        vec3 _285 = _161 * vec3(_277);
        float _290 = ((_181.y * 16.0) - _231) - _226;
        float _299 = sin(((_75._m5.x * 4.0) * _187) + _290);
        float _309 = cos(((_75._m5.x * 3.3299999237060546875) * _187) + _290);
        float _319 = (_299 + _309) * (-_181.w);
        vec3 _327 = vec3(_299 * _177, _309 * _177, _319 * _190) * vec3(_277);
        vec3 _341 = ((_285 + _327) * _75._m4.z) * _181.z;
        vec3 _354 = _196.xyz + _341;
        _196 = vec4(_354.x, _354.y, _354.z, _196.w);
        _196.w = 1.0;
        _123.x = dot(_196, _34._m4);
        _123.y = dot(_196, _34._m5);
        _123.z = dot(_196, _34._m6);
    }
    if (_136._m2.z != 0.0)
    {
        vec4 _379 = _123;
        vec4 _381 = vec4(0.0);
        vec4 _383 = vec4(0.0);
        vec4 _384 = vec4(0.0);
        uvec4 _387 = uvec4(uint(_34._m7.x + _136._m2.x)) + uvec4(_182 * 255.0);
        if (_136._m2.z == 1.0)
        {
            uint _407 = _387.x;
            _381 = _413._m0[(_407 * 3u) + 0u];
            _383 = _413._m0[(_407 * 3u) + 1u];
            _384 = _413._m0[(_407 * 3u) + 2u];
        }
        else
        {
            float _430 = _431.w * 255.100006103515625;
            vec4 _437;
            _437.y = _430 - (floor(_430 / 128.0) * 128.0);
            float _446 = _447.w * 255.100006103515625;
            _437.z = floor(_446 / 16.0);
            _437.w = _446 - (_437.z * 16.0);
            _437.y *= 0.00393700785934925079345703125;
            _437.z *= 0.02222222276031970977783203125;
            _437.w *= 0.01666666753590106964111328125;
            _437.x = 1.0 - ((_437.y + _437.z) + _437.w);
            for (uint _486 = 0u; _486 < 4u; _486++)
            {
                _381 += (_413._m0[(_387[_486] * 3u) + 0u] * _437[_486]);
            }
            for (uint _510 = 0u; _510 < 4u; _510++)
            {
                _383 += (_413._m0[(_387[_510] * 3u) + 1u] * _437[_510]);
            }
            for (uint _533 = 0u; _533 < 4u; _533++)
            {
                _384 += (_413._m0[(_387[_533] * 3u) + 2u] * _437[_533]);
            }
        }
        vec4 _556 = _379;
        vec4 _558 = _381;
        _123.x = _12(_556, _558);
        vec4 _562 = _379;
        vec4 _564 = _383;
        _123.y = _12(_562, _564);
        vec4 _568 = _379;
        vec4 _570 = _384;
        _123.z = _12(_568, _570);
        _123.w = 1.0;
    }
    vec4 _579 = _123;
    vec4 _581 = _111;
    gl_Position.x = _12(_579, _581);
    vec4 _586 = _123;
    vec4 _588 = _114;
    gl_Position.y = _12(_586, _588);
    vec4 _592 = _123;
    vec4 _594 = _117;
    gl_Position.z = _12(_592, _594);
    vec4 _598 = _123;
    vec4 _600 = _120;
    gl_Position.w = _12(_598, _600);
    vec4 _604 = vec4(_606, _608);
    _616 = _604 + _136._m3;
    _623 = uvec3(0u);
    gl_Position.y = -gl_Position.y;
}

