// BODY 3
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _378
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _117_119
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _119;

layout(set = 1, binding = 0, std140) uniform _138_140
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
} _140;

layout(set = 0, binding = 1, std430) restrict readonly buffer _163_165
{
    vec4 _m0[];
} _165;

layout(set = 0, binding = 2, std430) restrict readonly buffer _380_382
{
    _378 _m0[];
} _382;

layout(set = 0, binding = 0, std140) uniform _532_534
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _534;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1322_1324
{
    uint _m0[];
} _1324;

layout(set = 0, binding = 15, std140) uniform _1327_1329
{
    vec4 _m0[4096];
} _1329;

layout(set = 0, binding = 16, std140) uniform _1331_1333
{
    vec4 _m0[4096];
} _1333;

layout(set = 0, binding = 17, std140) uniform _1336_1338
{
    vec4 _m0[3072];
} _1338;

layout(set = 0, binding = 20, std140) uniform _1348_1350
{
    vec4 _m0[4095];
} _1350;

layout(set = 0, binding = 22, std140) uniform _1356_1358
{
    vec4 _m0[4096];
} _1358;

layout(push_constant, std430) uniform _383_385
{
    int _m0;
    int _m1;
} _385;

layout(set = 0, binding = 3) uniform sampler3D _723;
layout(set = 0, binding = 4) uniform sampler3D _805;
layout(set = 0, binding = 5) uniform sampler _1313;
layout(set = 0, binding = 6) uniform sampler _1314;
layout(set = 0, binding = 7) uniform sampler _1315;
layout(set = 0, binding = 8) uniform sampler _1316;
layout(set = 0, binding = 9) uniform sampler _1317;
layout(set = 0, binding = 10) uniform sampler _1318;
layout(set = 0, binding = 11) uniform sampler _1319;
layout(set = 0, binding = 12) uniform sampler _1320;
layout(set = 0, binding = 18) uniform samplerCubeArray _1342;
layout(set = 0, binding = 19) uniform sampler2D _1346;
layout(set = 0, binding = 21) uniform sampler2DShadow _1354;
layout(set = 0, binding = 23) uniform sampler2D _1359;
layout(set = 0, binding = 24) uniform sampler2D _1360;
layout(set = 1, binding = 1) uniform sampler2D _1361;
layout(set = 1, binding = 2) uniform sampler2D _1362;

layout(location = 15) out vec4 _67;
layout(location = 14) flat out uvec3 _75;
layout(location = 0) in vec4 _83;
layout(location = 2) in vec4 _91;
layout(location = 9) in vec4 _98;
layout(location = 3) in vec4 _147;
layout(location = 3) out vec4 _437;
layout(location = 4) out vec4 _461;
layout(location = 5) out vec4 _484;
layout(location = 6) out vec4 _530;
layout(location = 1) in vec2 _541;
layout(location = 12) in vec2 _543;
layout(location = 2) out vec4 _550;
layout(location = 10) out vec4 _562;
layout(location = 11) out vec4 _563;
layout(location = 12) out vec4 _564;
layout(location = 8) out vec4 _922;

float _27(vec4 _25, vec4 _26)
{
    return dot(_25, _26);
}

float _23(vec4 _21, vec4 _22)
{
    return dot(_21.xyz, _22.xyz);
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

float _16(vec3 _14, vec3 _15)
{
    return dot(_14, _15);
}

void main()
{
    vec4 _54 = vec4(0.0);
    vec3 _56 = vec3(0.0);
    uvec2 _61 = uvec2(0u);
    uint _65 = 0u;
    _67 = vec4(_56, 0.0);
    _75 = uvec3(_61.x, _61.y, 0u);
    _54 = vec4(_83.xyz, 1.0);
    vec4 _90 = (_91 * 2.0) - vec4(1.0);
    vec4 _97 = (_98 * 2.0) - vec4(1.0);
    _97.w = (floor((_98.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _116 = 0.0;
    if (_119._m0.z != 0.0)
    {
        vec4 _130 = _54;
        vec4 _132 = vec4(0.0);
        vec4 _133 = vec4(0.0);
        vec4 _134 = vec4(0.0);
        uvec4 _137 = uvec4(uint(_140._m0.x + _119._m0.x)) + uvec4(_147 * 255.0);
        if (_119._m0.z == 1.0)
        {
            uint _159 = _137.x;
            _132 = _165._m0[(_159 * 3u) + 0u];
            _133 = _165._m0[(_159 * 3u) + 1u];
            _134 = _165._m0[(_159 * 3u) + 2u];
        }
        else
        {
            float _183 = _98.w * 255.100006103515625;
            vec4 _187;
            _187.y = _183 - (floor(_183 / 128.0) * 128.0);
            float _195 = _91.w * 255.100006103515625;
            _187.z = floor(_195 / 16.0);
            _187.w = _195 - (_187.z * 16.0);
            _187.y *= 0.00393700785934925079345703125;
            _187.z *= 0.02222222276031970977783203125;
            _187.w *= 0.01666666753590106964111328125;
            _187.x = 1.0 - ((_187.y + _187.z) + _187.w);
            for (uint _235 = 0u; _235 < 4u; _235++)
            {
                _132 += (_165._m0[(_137[_235] * 3u) + 0u] * _187[_235]);
            }
            for (uint _260 = 0u; _260 < 4u; _260++)
            {
                _133 += (_165._m0[(_137[_260] * 3u) + 1u] * _187[_260]);
            }
            for (uint _283 = 0u; _283 < 4u; _283++)
            {
                _134 += (_165._m0[(_137[_283] * 3u) + 2u] * _187[_283]);
            }
        }
        vec4 _306 = _130;
        vec4 _308 = _132;
        _54.x = _27(_306, _308);
        vec4 _312 = _130;
        vec4 _314 = _133;
        _54.y = _27(_312, _314);
        vec4 _318 = _130;
        vec4 _320 = _134;
        _54.z = _27(_318, _320);
        _54.w = 1.0;
        vec4 _325 = _90;
        vec4 _327 = _325;
        vec4 _329 = _132;
        _90.x = _23(_327, _329);
        vec4 _333 = _325;
        vec4 _335 = _133;
        _90.y = _23(_333, _335);
        vec4 _339 = _325;
        vec4 _341 = _134;
        _90.z = _23(_339, _341);
        vec4 _345 = _97;
        vec4 _347 = _345;
        vec4 _349 = _132;
        _97.x = _23(_347, _349);
        vec4 _353 = _345;
        vec4 _355 = _133;
        _97.y = _23(_353, _355);
        vec4 _359 = _345;
        vec4 _361 = _134;
        _97.z = _23(_359, _361);
    }
    vec3 _373 = cross(_90.xyz, _97.xyz) * _97.w;
    vec4 _365;
    _365 = vec4(_373.x, _373.y, _373.z, _365.w);
    _365.w = 0.0;
    vec4 _377 = _382._m0[_385._m1]._m0;
    vec4 _391 = _382._m0[_385._m1]._m1;
    vec4 _396 = _382._m0[_385._m1]._m2;
    vec4 _402 = _382._m0[_385._m1]._m3;
    vec4 _412 = _54;
    vec4 _414 = _377;
    gl_Position.x = _27(_412, _414);
    vec4 _419 = _54;
    vec4 _421 = _391;
    gl_Position.y = _27(_419, _421);
    vec4 _425 = _54;
    vec4 _427 = _396;
    gl_Position.z = _27(_425, _427);
    vec4 _431 = _54;
    vec4 _433 = _402;
    gl_Position.w = _27(_431, _433);
    vec4 _438 = _97;
    vec4 _440 = _140._m1;
    _437.x = _23(_438, _440);
    vec4 _445 = _365;
    vec4 _447 = _140._m1;
    _437.y = _23(_445, _447);
    vec4 _452 = _90;
    vec4 _454 = _140._m1;
    _437.z = _23(_452, _454);
    _437.w = _116;
    vec4 _462 = _97;
    vec4 _464 = _140._m2;
    _461.x = _23(_462, _464);
    vec4 _469 = _365;
    vec4 _471 = _140._m2;
    _461.y = _23(_469, _471);
    vec4 _476 = _90;
    vec4 _478 = _140._m2;
    _461.z = _23(_476, _478);
    _461.w = 0.0;
    vec4 _485 = _97;
    vec4 _487 = _140._m3;
    _484.x = _23(_485, _487);
    vec4 _492 = _365;
    vec4 _494 = _140._m3;
    _484.y = _23(_492, _494);
    vec4 _499 = _90;
    vec4 _501 = _140._m3;
    _484.z = _23(_499, _501);
    _484.w = 0.0;
    vec4 _508 = _54;
    vec4 _510 = _140._m1;
    vec4 _507;
    _507.x = _27(_508, _510);
    vec4 _515 = _54;
    vec4 _517 = _140._m2;
    _507.y = _27(_515, _517);
    vec4 _522 = _54;
    vec4 _524 = _140._m3;
    _507.z = _27(_522, _524);
    _507.w = 1.0;
    _530 = _507 - _534._m0;
    vec4 _538 = vec4(_541, _543);
    _550 = _538 + _119._m1;
    vec3 _555 = _530.xyz + _534._m0.xyz;
    _562 = vec4(0.0);
    _563 = vec4(0.0);
    _564 = vec4(0.0);
    float _565 = float(_534._m1.x > 0.0);
    float _570 = _534._m1.x * _140._m4.x;
    bool _580 = _534._m1.y > 0.0;
    bool _587;
    if (!_580)
    {
        _587 = _534._m1.z > 0.0;
    }
    else
    {
        _587 = _580;
    }
    bool _594;
    if (!_587)
    {
        _594 = _534._m1.w > 0.0;
    }
    else
    {
        _594 = _587;
    }
    float _577 = float(_594);
    vec3 _596 = vec3(0.579999983310699462890625) * _534._m1.yzw;
    _562 = vec4(_534._m1.y, _534._m1.z, _534._m1.w, _596.x);
    _563 = vec4(_596.y, _596.z, _596.x, _596.y);
    _564 = vec4(_596.z, _596.x, _596.y, _596.z);
    if ((_565 > 0.0) && (_577 <= 0.0))
    {
        float _637 = -4096.0;
        float _639 = 4096.0;
        float _641 = 256.0;
        float _643 = 256.0;
        float _644 = 6.0;
        float _646 = 256.0;
        float _647 = 256.0;
        float _648 = 24.0;
        vec3 _650 = vec3(1.0 / _646, 1.0 / _647, 1.0 / _648);
        vec3 _658 = vec3(2.0 / _646, 2.0 / _647, 2.0 / _648);
        vec3 _666 = vec3(1.0 / _641, 1.0 / _643, 1.0 / _644);
        float _674 = 1.0 / (_639 - _637);
        vec3 _686 = (_555 - vec3(_637)) * _674;
        vec3 _679 = _11(_686);
        vec4 _688 = vec4(0.0);
        uvec3 _690 = uvec3(0u);
        for (uint _692 = 0u; _692 < 13u; _692++)
        {
            vec3 _701 = vec3(0.5) + floor(vec3(2.0) * _679);
            vec4 _709 = vec4(_666 * (vec3(_690) + _701), 0.0);
            _688 = textureLod(_723, _709.xyz, _709.w);
            _679 = fract(_679 * vec3(2.0));
            _690 = uvec3(_688.zyx * vec3(255.0));
            if (_688.w > 0.0)
            {
                break;
            }
        }
        uint _746 = (((uint(_688.w * 255.0) << uint(24)) | (uint(_688.z * 255.0) << uint(16))) | (uint(_688.y * 255.0) << uint(8))) | uint(_688.x * 255.0);
        uvec3 _772 = uvec3((_746 >> uint(19)) & 4095u, (_746 >> uint(7)) & 4095u, _746 & 127u);
        vec3 _786 = vec3(2.0) * ((_679 * vec3(0.5)) + vec3(0.25));
        vec4 _793 = vec4(_650 * (vec3(_772) + _786), 0.0);
        vec4 _804 = textureLod(_805, vec4(_793.xy, _793.z + (_658.z * 0.0), 0.0).xyz, vec4(_793.xy, _793.z + (_658.z * 0.0), 0.0).w) * _570;
        vec4 _834 = textureLod(_805, vec4(_793.xy, _793.z + (_658.z * 1.0), 0.0).xyz, vec4(_793.xy, _793.z + (_658.z * 1.0), 0.0).w) * _570;
        vec4 _863 = textureLod(_805, vec4(_793.xy, _793.z + (_658.z * 2.0), 0.0).xyz, vec4(_793.xy, _793.z + (_658.z * 2.0), 0.0).w) * _570;
        _562 = vec4(_804.x, _834.x, _863.x, _804.y);
        _563 = vec4(_834.y, _863.y, _804.z, _834.z);
        _564 = vec4(_863.z, _804.w, _834.w, _863.w);
    }
    vec3 _919 = _83.xyz;
    _922 = vec4(0.0);
    vec3 _923 = (_140._m5.xyz - _919) * _140._m5.w;
    vec3 _933 = (_140._m6.xyz - _919) * _140._m6.w;
    vec3 _943 = (_140._m7.xyz - _919) * _140._m7.w;
    vec3 _952 = (_140._m8.xyz - _919) * _140._m8.w;
    vec3 _961 = (_140._m9.xyz - _919) * _140._m9.w;
    vec3 _971 = (_140._m10.xyz - _919) * _140._m10.w;
    vec3 _981 = (_140._m11.xyz - _919) * _140._m11.w;
    vec3 _991 = (_140._m12.xyz - _919) * _140._m12.w;
    vec3 _1001 = (_140._m13.xyz - _919) * _140._m13.w;
    vec3 _1011 = (_140._m14.xyz - _919) * _140._m14.w;
    vec3 _1021 = (_140._m15.xyz - _919) * _140._m15.w;
    vec3 _1031 = (_140._m16.xyz - _919) * _140._m16.w;
    vec3 _1040 = (_140._m17.xyz - _919) * _140._m17.w;
    vec3 _1050 = (_140._m18.xyz - _919) * _140._m18.w;
    vec3 _1060 = (_140._m19.xyz - _919) * _140._m19.w;
    vec3 _1069 = (_140._m20.xyz - _919) * _140._m20.w;
    vec3 _1079 = (_140._m21.xyz - _919) * _140._m21.w;
    vec3 _1089 = (_140._m22.xyz - _919) * _140._m22.w;
    vec3 _1099 = (_140._m23.xyz - _919) * _140._m23.w;
    vec3 _1109 = (_140._m24.xyz - _919) * _140._m24.w;
    vec3 _1119 = _923;
    vec3 _1121 = _923;
    float _1118 = _16(_1119, _1121);
    vec3 _1125 = _933;
    vec3 _1127 = _933;
    float _1124 = _16(_1125, _1127);
    vec3 _1131 = _943;
    vec3 _1133 = _943;
    float _1130 = _16(_1131, _1133);
    vec3 _1137 = _952;
    vec3 _1139 = _952;
    float _1136 = _16(_1137, _1139);
    vec3 _1143 = _961;
    vec3 _1145 = _961;
    float _1142 = _16(_1143, _1145);
    vec3 _1149 = _971;
    vec3 _1151 = _971;
    float _1148 = _16(_1149, _1151);
    vec3 _1155 = _981;
    vec3 _1157 = _981;
    float _1154 = _16(_1155, _1157);
    vec3 _1161 = _991;
    vec3 _1163 = _991;
    float _1160 = _16(_1161, _1163);
    vec3 _1167 = _1001;
    vec3 _1169 = _1001;
    float _1166 = _16(_1167, _1169);
    vec3 _1173 = _1011;
    vec3 _1175 = _1011;
    float _1172 = _16(_1173, _1175);
    vec3 _1179 = _1021;
    vec3 _1181 = _1021;
    float _1178 = _16(_1179, _1181);
    vec3 _1185 = _1031;
    vec3 _1187 = _1031;
    float _1184 = _16(_1185, _1187);
    vec3 _1191 = _1040;
    vec3 _1193 = _1040;
    float _1190 = _16(_1191, _1193);
    vec3 _1197 = _1050;
    vec3 _1199 = _1050;
    float _1196 = _16(_1197, _1199);
    vec3 _1203 = _1060;
    vec3 _1205 = _1060;
    float _1202 = _16(_1203, _1205);
    vec3 _1209 = _1069;
    vec3 _1211 = _1069;
    float _1208 = _16(_1209, _1211);
    vec3 _1215 = _1079;
    vec3 _1217 = _1079;
    float _1214 = _16(_1215, _1217);
    vec3 _1221 = _1089;
    vec3 _1223 = _1089;
    float _1220 = _16(_1221, _1223);
    vec3 _1227 = _1099;
    vec3 _1229 = _1099;
    float _1226 = _16(_1227, _1229);
    vec3 _1233 = _1109;
    vec3 _1235 = _1109;
    float _1232 = _16(_1233, _1235);
    float _1238 = min(_1118, _1124);
    _1238 = min(_1238, _1130);
    _1238 = min(_1238, _1136);
    _1238 = min(_1238, _1142);
    _1238 = min(_1238, _1148);
    _1238 = min(_1238, _1154);
    _1238 = min(_1238, _1160);
    _1238 = min(_1238, _1166);
    _1238 = min(_1238, _1172);
    _1238 = min(_1238, _1178);
    _1238 = min(_1238, _1184);
    float _1272 = min(_1190, _1196);
    _1272 = min(_1272, _1202);
    _1272 = min(_1272, _1208);
    _1272 = min(_1272, _1214);
    _1272 = min(_1272, _1220);
    _1272 = min(_1272, _1226);
    _1272 = min(_1272, _1232);
    float _1294 = sqrt(min(_1238, _1272)) - 1.0;
    float _1300 = sqrt(_1238) - 1.0;
    _922 = vec4(_1294, 0.0, 0.0, _1300);
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}



