#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _369
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _78_80
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _80;

layout(set = 1, binding = 0, std140) uniform _100_102
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _102;

layout(set = 0, binding = 1, std430) restrict readonly buffer _127_129
{
    vec4 _m0[];
} _129;

layout(set = 0, binding = 2, std430) restrict readonly buffer _371_373
{
    _369 _m0[];
} _373;

layout(push_constant, std430) uniform _374_376
{
    int _m0;
    int _m1;
} _376;

layout(set = 2, binding = 1) uniform sampler2D _452;

layout(location = 0) in vec4 _44;
layout(location = 2) in vec4 _52;
layout(location = 9) in vec4 _59;
layout(location = 3) in vec4 _110;
layout(location = 1) in vec2 _430;
layout(location = 12) in vec2 _432;
layout(location = 2) out vec4 _440;

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

float _17(vec4 _15, vec4 _16)
{
    return dot(_15.xyz, _16.xyz);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    vec4 _42 = vec4(_44.xyz, 1.0);
    vec4 _51 = (_52 * 2.0) - vec4(1.0);
    vec4 _58 = (_59 * 2.0) - vec4(1.0);
    _58.w = (floor((_59.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _77 = 0.0;
    if (_80._m0.z != 0.0)
    {
        vec4 _91 = _42;
        vec4 _93 = vec4(0.0);
        vec4 _95 = vec4(0.0);
        vec4 _96 = vec4(0.0);
        uvec4 _99 = uvec4(uint(_102._m0.x + _80._m0.x)) + uvec4(_110 * 255.0);
        if (_80._m0.z == 1.0)
        {
            uint _123 = _99.x;
            _93 = _129._m0[(_123 * 3u) + 0u];
            _95 = _129._m0[(_123 * 3u) + 1u];
            _96 = _129._m0[(_123 * 3u) + 2u];
        }
        else
        {
            float _148 = _59.w * 255.100006103515625;
            vec4 _152;
            _152.y = _148 - (floor(_148 / 128.0) * 128.0);
            float _160 = _52.w * 255.100006103515625;
            _152.z = floor(_160 / 16.0);
            _152.w = _160 - (_152.z * 16.0);
            _152.y *= 0.00393700785934925079345703125;
            _152.z *= 0.02222222276031970977783203125;
            _152.w *= 0.01666666753590106964111328125;
            _152.x = 1.0 - ((_152.y + _152.z) + _152.w);
            for (uint _200 = 0u; _200 < 4u; _200++)
            {
                _93 += (_129._m0[(_99[_200] * 3u) + 0u] * _152[_200]);
            }
            for (uint _225 = 0u; _225 < 4u; _225++)
            {
                _95 += (_129._m0[(_99[_225] * 3u) + 1u] * _152[_225]);
            }
            for (uint _248 = 0u; _248 < 4u; _248++)
            {
                _96 += (_129._m0[(_99[_248] * 3u) + 2u] * _152[_248]);
            }
        }
        vec4 _271 = _91;
        vec4 _273 = _93;
        _42.x = _21(_271, _273);
        vec4 _277 = _91;
        vec4 _279 = _95;
        _42.y = _21(_277, _279);
        vec4 _283 = _91;
        vec4 _285 = _96;
        _42.z = _21(_283, _285);
        _42.w = 1.0;
        vec4 _290 = _51;
        vec4 _292 = _290;
        vec4 _294 = _93;
        _51.x = _17(_292, _294);
        vec4 _298 = _290;
        vec4 _300 = _95;
        _51.y = _17(_298, _300);
        vec4 _304 = _290;
        vec4 _306 = _96;
        _51.z = _17(_304, _306);
        vec4 _310 = _58;
        vec4 _312 = _310;
        vec4 _314 = _93;
        _58.x = _17(_312, _314);
        vec4 _318 = _310;
        vec4 _320 = _95;
        _58.y = _17(_318, _320);
        vec4 _324 = _310;
        vec4 _326 = _96;
        _58.z = _17(_324, _326);
    }
    float _330 = length(_102._m1.xyz - _42.xyz);
    float _348 = abs(_330 - _102._m2.z) / _102._m2.x;
    float _338 = 1.0 - _10(_348);
    float _351 = ((_338 * _338) * _102._m2.y) * 0.00999999977648258209228515625;
    _42 += (_51 * vec4(_351, _351, _351, 0.0));
    vec4 _368 = _373._m0[_376._m1]._m0;
    vec4 _382 = _373._m0[_376._m1]._m1;
    vec4 _387 = _373._m0[_376._m1]._m2;
    vec4 _392 = _373._m0[_376._m1]._m3;
    vec4 _402 = _42;
    vec4 _404 = _368;
    gl_Position.x = _21(_402, _404);
    vec4 _409 = _42;
    vec4 _411 = _382;
    gl_Position.y = _21(_409, _411);
    vec4 _415 = _42;
    vec4 _417 = _387;
    gl_Position.z = _21(_415, _417);
    vec4 _421 = _42;
    vec4 _423 = _392;
    gl_Position.w = _21(_421, _423);
    vec4 _427 = vec4(_430, _432);
    _440 = _427 + _80._m1;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
}


