// More GEometry stuff
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _356
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, std140) uniform _92_94
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _94;

layout(set = 1, binding = 0, std140) uniform _113_115
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _115;

layout(set = 0, binding = 1, std430) restrict readonly buffer _140_142
{
    vec4 _m0[];
} _142;

layout(set = 0, binding = 2, std430) restrict readonly buffer _358_360
{
    _356 _m0[];
} _360;

layout(set = 0, binding = 0, std140) uniform _511_513
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _513;

layout(set = 0, binding = 6, std430) restrict readonly buffer _1292_1294
{
    uint _m0[];
} _1294;

layout(set = 0, binding = 7, std140) uniform _1297_1299
{
    vec4 _m0[4096];
} _1299;

layout(set = 0, binding = 8, std140) uniform _1301_1303
{
    vec4 _m0[4096];
} _1303;

layout(set = 0, binding = 9, std140) uniform _1306_1308
{
    vec4 _m0[3072];
} _1308;

layout(set = 0, binding = 12, std140) uniform _1318_1320
{
    vec4 _m0[4095];
} _1320;

layout(push_constant, std430) uniform _361_363
{
    int _m0;
    int _m1;
} _363;

layout(set = 0, binding = 3) uniform sampler3D _703;
layout(set = 0, binding = 4) uniform sampler3D _785;
layout(set = 0, binding = 10) uniform samplerCubeArray _1312;
layout(set = 0, binding = 11) uniform sampler2D _1316;
layout(set = 0, binding = 13) uniform sampler2DShadow _1324;
layout(set = 1, binding = 1) uniform sampler2D _1325;
layout(set = 1, binding = 2) uniform sampler2D _1326;
layout(set = 2, binding = 1) uniform sampler2D _1327;
layout(set = 2, binding = 2) uniform sampler2D _1328;

layout(location = 0) in vec4 _57;
layout(location = 2) in vec4 _65;
layout(location = 9) in vec4 _72;
layout(location = 3) in vec4 _123;
layout(location = 3) out vec4 _416;
layout(location = 4) out vec4 _440;
layout(location = 5) out vec4 _463;
layout(location = 6) out vec4 _509;
layout(location = 1) in vec2 _520;
layout(location = 12) in vec2 _522;
layout(location = 2) out vec4 _529;
layout(location = 10) out vec4 _541;
layout(location = 11) out vec4 _542;
layout(location = 12) out vec4 _543;
layout(location = 8) out vec4 _902;

float _27(vec4 _25, vec4 _26)
{
    return dot(_25, _26);
}

float _23(vec4 _21, vec4 _22)
{
    return dot(_21.xyz, _22.xyz);
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

float _16(vec3 _14, vec3 _15)
{
    return dot(_14, _15);
}

void main()
{
    vec4 _54 = vec4(0.0);
    _54 = vec4(_57.xyz, 1.0);
    vec4 _64 = (_65 * 2.0) - vec4(1.0);
    vec4 _71 = (_72 * 2.0) - vec4(1.0);
    _71.w = (floor((_72.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _91 = 0.0;
    if (_94._m0.z != 0.0)
    {
        vec4 _105 = _54;
        vec4 _107 = vec4(0.0);
        vec4 _108 = vec4(0.0);
        vec4 _109 = vec4(0.0);
        uvec4 _112 = uvec4(uint(_115._m0.x + _94._m0.x)) + uvec4(_123 * 255.0);
        if (_94._m0.z == 1.0)
        {
            uint _136 = _112.x;
            _107 = _142._m0[(_136 * 3u) + 0u];
            _108 = _142._m0[(_136 * 3u) + 1u];
            _109 = _142._m0[(_136 * 3u) + 2u];
        }
        else
        {
            float _161 = _72.w * 255.100006103515625;
            vec4 _165;
            _165.y = _161 - (floor(_161 / 128.0) * 128.0);
            float _173 = _65.w * 255.100006103515625;
            _165.z = floor(_173 / 16.0);
            _165.w = _173 - (_165.z * 16.0);
            _165.y *= 0.00393700785934925079345703125;
            _165.z *= 0.02222222276031970977783203125;
            _165.w *= 0.01666666753590106964111328125;
            _165.x = 1.0 - ((_165.y + _165.z) + _165.w);
            for (uint _213 = 0u; _213 < 4u; _213++)
            {
                _107 += (_142._m0[(_112[_213] * 3u) + 0u] * _165[_213]);
            }
            for (uint _238 = 0u; _238 < 4u; _238++)
            {
                _108 += (_142._m0[(_112[_238] * 3u) + 1u] * _165[_238]);
            }
            for (uint _261 = 0u; _261 < 4u; _261++)
            {
                _109 += (_142._m0[(_112[_261] * 3u) + 2u] * _165[_261]);
            }
        }
        vec4 _284 = _105;
        vec4 _286 = _107;
        _54.x = _27(_284, _286);
        vec4 _290 = _105;
        vec4 _292 = _108;
        _54.y = _27(_290, _292);
        vec4 _296 = _105;
        vec4 _298 = _109;
        _54.z = _27(_296, _298);
        _54.w = 1.0;
        vec4 _303 = _64;
        vec4 _305 = _303;
        vec4 _307 = _107;
        _64.x = _23(_305, _307);
        vec4 _311 = _303;
        vec4 _313 = _108;
        _64.y = _23(_311, _313);
        vec4 _317 = _303;
        vec4 _319 = _109;
        _64.z = _23(_317, _319);
        vec4 _323 = _71;
        vec4 _325 = _323;
        vec4 _327 = _107;
        _71.x = _23(_325, _327);
        vec4 _331 = _323;
        vec4 _333 = _108;
        _71.y = _23(_331, _333);
        vec4 _337 = _323;
        vec4 _339 = _109;
        _71.z = _23(_337, _339);
    }
    vec3 _351 = cross(_64.xyz, _71.xyz) * _71.w;
    vec4 _343;
    _343 = vec4(_351.x, _351.y, _351.z, _343.w);
    _343.w = 0.0;
    vec4 _355 = _360._m0[_363._m1]._m0;
    vec4 _369 = _360._m0[_363._m1]._m1;
    vec4 _374 = _360._m0[_363._m1]._m2;
    vec4 _380 = _360._m0[_363._m1]._m3;
    vec4 _390 = _54;
    vec4 _392 = _355;
    gl_Position.x = _27(_390, _392);
    vec4 _397 = _54;
    vec4 _399 = _369;
    gl_Position.y = _27(_397, _399);
    vec4 _403 = _54;
    vec4 _405 = _374;
    gl_Position.z = _27(_403, _405);
    vec4 _409 = _54;
    vec4 _411 = _380;
    gl_Position.w = _27(_409, _411);
    vec4 _417 = _71;
    vec4 _419 = _115._m1;
    _416.x = _23(_417, _419);
    vec4 _424 = _343;
    vec4 _426 = _115._m1;
    _416.y = _23(_424, _426);
    vec4 _431 = _64;
    vec4 _433 = _115._m1;
    _416.z = _23(_431, _433);
    _416.w = _91;
    vec4 _441 = _71;
    vec4 _443 = _115._m2;
    _440.x = _23(_441, _443);
    vec4 _448 = _343;
    vec4 _450 = _115._m2;
    _440.y = _23(_448, _450);
    vec4 _455 = _64;
    vec4 _457 = _115._m2;
    _440.z = _23(_455, _457);
    _440.w = 0.0;
    vec4 _464 = _71;
    vec4 _466 = _115._m3;
    _463.x = _23(_464, _466);
    vec4 _471 = _343;
    vec4 _473 = _115._m3;
    _463.y = _23(_471, _473);
    vec4 _478 = _64;
    vec4 _480 = _115._m3;
    _463.z = _23(_478, _480);
    _463.w = 0.0;
    vec4 _487 = _54;
    vec4 _489 = _115._m1;
    vec4 _486;
    _486.x = _27(_487, _489);
    vec4 _494 = _54;
    vec4 _496 = _115._m2;
    _486.y = _27(_494, _496);
    vec4 _501 = _54;
    vec4 _503 = _115._m3;
    _486.z = _27(_501, _503);
    _486.w = 1.0;
    _509 = _486 - _513._m0;
    vec4 _517 = vec4(_520, _522);
    _529 = _517 + _94._m1;
    vec3 _534 = _509.xyz + _513._m0.xyz;
    _541 = vec4(0.0);
    _542 = vec4(0.0);
    _543 = vec4(0.0);
    float _544 = float(_513._m1.x > 0.0);
    float _549 = _513._m1.x * _115._m4.x;
    bool _559 = _513._m1.y > 0.0;
    bool _566;
    if (!_559)
    {
        _566 = _513._m1.z > 0.0;
    }
    else
    {
        _566 = _559;
    }
    bool _573;
    if (!_566)
    {
        _573 = _513._m1.w > 0.0;
    }
    else
    {
        _573 = _566;
    }
    float _556 = float(_573);
    vec3 _575 = vec3(0.579999983310699462890625) * _513._m1.yzw;
    _541 = vec4(_513._m1.y, _513._m1.z, _513._m1.w, _575.x);
    _542 = vec4(_575.y, _575.z, _575.x, _575.y);
    _543 = vec4(_575.z, _575.x, _575.y, _575.z);
    if ((_544 > 0.0) && (_556 <= 0.0))
    {
        float _616 = -4096.0;
        float _618 = 4096.0;
        float _620 = 256.0;
        float _622 = 256.0;
        float _623 = 6.0;
        float _625 = 256.0;
        float _626 = 256.0;
        float _627 = 24.0;
        vec3 _629 = vec3(1.0 / _625, 1.0 / _626, 1.0 / _627);
        vec3 _637 = vec3(2.0 / _625, 2.0 / _626, 2.0 / _627);
        vec3 _645 = vec3(1.0 / _620, 1.0 / _622, 1.0 / _623);
        float _653 = 1.0 / (_618 - _616);
        vec3 _665 = (_534 - vec3(_616)) * _653;
        vec3 _658 = _11(_665);
        vec4 _667 = vec4(0.0);
        uvec3 _670 = uvec3(0u);
        for (uint _672 = 0u; _672 < 13u; _672++)
        {
            vec3 _681 = vec3(0.5) + floor(vec3(2.0) * _658);
            vec4 _689 = vec4(_645 * (vec3(_670) + _681), 0.0);
            _667 = textureLod(_703, _689.xyz, _689.w);
            _658 = fract(_658 * vec3(2.0));
            _670 = uvec3(_667.zyx * vec3(255.0));
            if (_667.w > 0.0)
            {
                break;
            }
        }
        uint _726 = (((uint(_667.w * 255.0) << uint(24)) | (uint(_667.z * 255.0) << uint(16))) | (uint(_667.y * 255.0) << uint(8))) | uint(_667.x * 255.0);
        uvec3 _752 = uvec3((_726 >> uint(19)) & 4095u, (_726 >> uint(7)) & 4095u, _726 & 127u);
        vec3 _766 = vec3(2.0) * ((_658 * vec3(0.5)) + vec3(0.25));
        vec4 _773 = vec4(_629 * (vec3(_752) + _766), 0.0);
        vec4 _784 = textureLod(_785, vec4(_773.xy, _773.z + (_637.z * 0.0), 0.0).xyz, vec4(_773.xy, _773.z + (_637.z * 0.0), 0.0).w) * _549;
        vec4 _814 = textureLod(_785, vec4(_773.xy, _773.z + (_637.z * 1.0), 0.0).xyz, vec4(_773.xy, _773.z + (_637.z * 1.0), 0.0).w) * _549;
        vec4 _843 = textureLod(_785, vec4(_773.xy, _773.z + (_637.z * 2.0), 0.0).xyz, vec4(_773.xy, _773.z + (_637.z * 2.0), 0.0).w) * _549;
        _541 = vec4(_784.x, _814.x, _843.x, _784.y);
        _542 = vec4(_814.y, _843.y, _784.z, _814.z);
        _543 = vec4(_843.z, _784.w, _814.w, _843.w);
    }
    vec3 _899 = _57.xyz;
    _902 = vec4(0.0);
    vec3 _903 = (_115._m5.xyz - _899) * _115._m5.w;
    vec3 _913 = (_115._m6.xyz - _899) * _115._m6.w;
    vec3 _923 = (_115._m7.xyz - _899) * _115._m7.w;
    vec3 _932 = (_115._m8.xyz - _899) * _115._m8.w;
    vec3 _941 = (_115._m9.xyz - _899) * _115._m9.w;
    vec3 _951 = (_115._m10.xyz - _899) * _115._m10.w;
    vec3 _961 = (_115._m11.xyz - _899) * _115._m11.w;
    vec3 _971 = (_115._m12.xyz - _899) * _115._m12.w;
    vec3 _981 = (_115._m13.xyz - _899) * _115._m13.w;
    vec3 _991 = (_115._m14.xyz - _899) * _115._m14.w;
    vec3 _1001 = (_115._m15.xyz - _899) * _115._m15.w;
    vec3 _1011 = (_115._m16.xyz - _899) * _115._m16.w;
    vec3 _1020 = (_115._m17.xyz - _899) * _115._m17.w;
    vec3 _1030 = (_115._m18.xyz - _899) * _115._m18.w;
    vec3 _1040 = (_115._m19.xyz - _899) * _115._m19.w;
    vec3 _1049 = (_115._m20.xyz - _899) * _115._m20.w;
    vec3 _1059 = (_115._m21.xyz - _899) * _115._m21.w;
    vec3 _1069 = (_115._m22.xyz - _899) * _115._m22.w;
    vec3 _1079 = (_115._m23.xyz - _899) * _115._m23.w;
    vec3 _1089 = (_115._m24.xyz - _899) * _115._m24.w;
    vec3 _1099 = _903;
    vec3 _1101 = _903;
    float _1098 = _16(_1099, _1101);
    vec3 _1105 = _913;
    vec3 _1107 = _913;
    float _1104 = _16(_1105, _1107);
    vec3 _1111 = _923;
    vec3 _1113 = _923;
    float _1110 = _16(_1111, _1113);
    vec3 _1117 = _932;
    vec3 _1119 = _932;
    float _1116 = _16(_1117, _1119);
    vec3 _1123 = _941;
    vec3 _1125 = _941;
    float _1122 = _16(_1123, _1125);
    vec3 _1129 = _951;
    vec3 _1131 = _951;
    float _1128 = _16(_1129, _1131);
    vec3 _1135 = _961;
    vec3 _1137 = _961;
    float _1134 = _16(_1135, _1137);
    vec3 _1141 = _971;
    vec3 _1143 = _971;
    float _1140 = _16(_1141, _1143);
    vec3 _1147 = _981;
    vec3 _1149 = _981;
    float _1146 = _16(_1147, _1149);
    vec3 _1153 = _991;
    vec3 _1155 = _991;
    float _1152 = _16(_1153, _1155);
    vec3 _1159 = _1001;
    vec3 _1161 = _1001;
    float _1158 = _16(_1159, _1161);
    vec3 _1165 = _1011;
    vec3 _1167 = _1011;
    float _1164 = _16(_1165, _1167);
    vec3 _1171 = _1020;
    vec3 _1173 = _1020;
    float _1170 = _16(_1171, _1173);
    vec3 _1177 = _1030;
    vec3 _1179 = _1030;
    float _1176 = _16(_1177, _1179);
    vec3 _1183 = _1040;
    vec3 _1185 = _1040;
    float _1182 = _16(_1183, _1185);
    vec3 _1189 = _1049;
    vec3 _1191 = _1049;
    float _1188 = _16(_1189, _1191);
    vec3 _1195 = _1059;
    vec3 _1197 = _1059;
    float _1194 = _16(_1195, _1197);
    vec3 _1201 = _1069;
    vec3 _1203 = _1069;
    float _1200 = _16(_1201, _1203);
    vec3 _1207 = _1079;
    vec3 _1209 = _1079;
    float _1206 = _16(_1207, _1209);
    vec3 _1213 = _1089;
    vec3 _1215 = _1089;
    float _1212 = _16(_1213, _1215);
    float _1218 = min(_1098, _1104);
    _1218 = min(_1218, _1110);
    _1218 = min(_1218, _1116);
    _1218 = min(_1218, _1122);
    _1218 = min(_1218, _1128);
    _1218 = min(_1218, _1134);
    _1218 = min(_1218, _1140);
    _1218 = min(_1218, _1146);
    _1218 = min(_1218, _1152);
    _1218 = min(_1218, _1158);
    _1218 = min(_1218, _1164);
    float _1252 = min(_1170, _1176);
    _1252 = min(_1252, _1182);
    _1252 = min(_1252, _1188);
    _1252 = min(_1252, _1194);
    _1252 = min(_1252, _1200);
    _1252 = min(_1252, _1206);
    _1252 = min(_1252, _1212);
    float _1274 = sqrt(min(_1218, _1252)) - 1.0;
    float _1280 = sqrt(_1218) - 1.0;
    _902 = vec4(_1274, 0.0, 0.0, _1280);
    gl_Position.y = -gl_Position.y;

 // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


